#pragma once

/*
 *()
 *	T ɂ̓fXgN^Ń|C^悤ȍ\ɂȂĂNX͗^ȂB
 *	R͖BT ̔zړ̂ memcpy  memmove gAsvɂȂz
 *	 delete[] Ă邩B
 *	memcpy ňړƁAT ̃oϐ̒l͂̂܂܃Rs[BRs[ƃRs[
 *	悪l̃|C^ĂȂARs[ delete[] ŃfXgN^
 *	ĂяoāARs[̎Ă|C^͖ȃAhXwƂɂȂB
 */
template < class T, int iSize >
class CVarbuffer {
protected:
	T			m_tInternal [iSize] ;
	T*			m_pBuffer ;
	int			m_iSize ;
	int			m_iUsage ;
public:
	CVarbuffer () : m_pBuffer (m_tInternal), m_iSize (iSize), m_iUsage (0) {
		return ;
	} 

	CVarbuffer (const CVarbuffer< T, iSize >& buffer) {
		if (buffer.m_iUsage > iSize){
			int	iNewSize ;
			iNewSize		= (buffer.m_iUsage / iSize + 1) * iSize ;
			m_pBuffer	= new T[iNewSize] ;
			m_iSize	= iNewSize ;
		} else {
			m_pBuffer	= m_tInternal ;
		}
		::memcpy (m_pBuffer, buffer.m_pBuffer, sizeof (T) * buffer.m_iUsage) ;
		m_iSize	= buffer.m_iSize ;
		m_iUsage	= buffer.m_iUsage ;
		return ;
	}

	virtual	~CVarbuffer () {
		if (m_pBuffer != m_tInternal){
			delete[] m_pBuffer ;
			m_pBuffer	= m_tInternal ;
		}
		m_iSize	= iSize ;
		m_iUsage	= 0 ;
		return ;
	}

	virtual int			iGetUsage () const {
		return m_iUsage ;
	}

	virtual int			iGetSize () const {
		return m_iSize ;
	}

	virtual const T*	pGetBuffer () const {
		return m_pBuffer ;
	}

	virtual T*			pGetBuffer () {
		return m_pBuffer ;
	}

	virtual void		vClear () {
		if (m_pBuffer != m_tInternal){
			delete[] m_pBuffer ;
			m_pBuffer	= m_tInternal ;
		}
		m_iSize	= iSize ;
		m_iUsage	= 0 ;
		return ;
	}

	virtual bool		bAdd (const T& tValue){
		if ((m_iUsage + 1) > m_iSize){
			T*			pNewBuffer ;
			int			iNewSize ;
			iNewSize	= ((m_iUsage + 1) / iSize + 1) * iSize ;
			pNewBuffer	= new T[iNewSize] ;
			::memcpy (pNewBuffer, m_pBuffer, sizeof (T) * m_iUsage) ;
			if (m_pBuffer != m_tInternal)
				delete[] m_pBuffer ;
			m_pBuffer	= pNewBuffer ;
			m_iSize	= iNewSize ;
		}
		m_pBuffer [m_iUsage ++] = tValue ;
		return true ;
	}

	virtual bool		bAdd (const T* lptValue, int iLength){
		if (lptValue == NULL || iLength <= 0)
			return false ;
		if ((m_iUsage + iLength) > m_iSize){
			T*	pNewBuffer ;
			int	iNewSize ;
			iNewSize		= ((m_iUsage + iLength) / iSize + 1) * iSize ;
			pNewBuffer		= new T[iNewSize] ;
			::memcpy (pNewBuffer, m_pBuffer, sizeof (T) * m_iUsage) ;
			if (m_pBuffer != m_tInternal)
				delete[] m_pBuffer ;
			m_pBuffer	= pNewBuffer ;
			m_iSize	= iNewSize ;
		}
		::memcpy (m_pBuffer + m_iUsage, lptValue, sizeof (T) * iLength) ;
		m_iUsage	+= iLength ;
		return true ;
	}

	virtual bool		bRequire (int iLength){
		if (iLength < 0)
			return bSub (- iLength) ;
		if ((m_iUsage + iLength) > m_iSize){
			T*	pNewBuffer ;
			int	iNewSize ;
			iNewSize		= ((m_iUsage + iLength) / iSize + 1) * iSize ;
			pNewBuffer	= new T[iNewSize] ;
			::memcpy (pNewBuffer, m_pBuffer, sizeof (T) * m_iUsage) ;
			if (m_pBuffer != m_tInternal)
				delete[] m_pBuffer ;
			m_pBuffer	= pNewBuffer ;
			m_iSize	= iNewSize ;
		}
		m_iUsage += iLength ;
		return true ;
	}

	virtual bool		bSub (int iLength){
		if (iLength < 0)
			return bRequire (- iLength) ;
		m_iUsage -= iLength ;
		if (m_iUsage <= 0){
			m_iUsage = 0 ;
			//	obt@ł̓̂ŁA^C~OŉB
			if (m_pBuffer != m_tInternal){
				delete[] m_pBuffer ; 
				m_pBuffer	= m_tInternal ;
				m_iSize	= iSize ;
			}
		}
		return true ;
	}

	CVarbuffer< T, iSize >&		operator=(const CVarbuffer< T, iSize >& buffer) {
		Clear () ;
		Add (buffer.GetBuffer(), buffer.GetUsage()) ;
		return (*this) ;
	}
} ;

