/*	keys.cpp
 *
 *	ITfKeyEventSink	implementation
 *
 *
 *	lȂ΂ȂȂ̂́A
 *		(1) L[Xg[N IME ɓn̂́A̎dȂ̂H
 *		(2)  IME ̏ɈړȂ΂ȂȂ̂H
 *	2_ł낤B(1) 𑁊KvB܂
 *	Ă݂AȂB
 */
#include "globals.h"
#include "skimic.h"
#include "editsess.h"
#include "skkimmgr.h"
#include "IME\ImeConfig.h"

class CKeystrokeEditSession : public CEditSessionBase
{
public:
    CKeystrokeEditSession (ITfContext *pContext, WPARAM wParam, LPARAM lParam, DWORD dwMask, CSkkImeMgr* pSkkIme) :
		CEditSessionBase(pContext)
	{
		m_wParam 	= wParam ;
		m_lParam	= lParam ;
		m_dwMask	= dwMask ;
		m_pSkkIme	= pSkkIme ;
		return ;
	}
	
    // ITfEditSession
    STDMETHODIMP DoEditSession (TfEditCookie ec) ;
	
private:
    WPARAM		m_wParam ;
	LPARAM		m_lParam ;
	DWORD		m_dwMask ;
	CSkkImeMgr*	m_pSkkIme ;
} ;

class CToggleImeEditSession : public CEditSessionBase {
public:
	CToggleImeEditSession (ITfContext* pContext, CSkkImeMgr* pSkkIme) : CEditSessionBase (pContext), m_pSkkIme (pSkkIme) {
		return ;
	}
	STDMETHODIMP	DoEditSession (TfEditCookie ec) ;
private:
	CSkkImeMgr*	m_pSkkIme ;
} ;


/*	_InitKeystrokeSink
 *
 *	Advise a keystroke sink.
 */
BOOL
CSkkImeTextService::_InitKeystrokeSink ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
    HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
    if (m_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return	FALSE ;

    hr = pKeystrokeMgr->AdviseKeyEventSink(m_tfClientId, (ITfKeyEventSink *)this, TRUE);
	
    pKeystrokeMgr->Release () ;

    return	(hr == S_OK) ;
}


/*	_UninitKeystrokeSink
 *
 *	Unadvise a keystroke sink.  Assumes we have advised one already.
 */
void
CSkkImeTextService::_UninitKeystrokeSink ()
{
    ITfKeystrokeMgr *pKeystrokeMgr;

	if (m_pThreadMgr == NULL)
		return ;

    if (m_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return;

    pKeystrokeMgr->UnadviseKeyEventSink (m_tfClientId) ;
    pKeystrokeMgr->Release () ;
}

/*	Hot Key o^B
 *
 *	o^ꂽ Hot Key ꂽǂ OnPreservedKey 
 *	`FbNłB
 */
BOOL
CSkkImeTextService::_InitPreservedKey ()
{
	static LPCWSTR		wstrDesc	= L"Toggle IME" ;
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	TF_PRESERVEDKEY		key ;
	HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return	FALSE ;

	/*	register KANJI key */
	key.uVKey		= VK_KANJI ;
	key.uModifiers	= TF_MOD_IGNORE_ALL_MODIFIER ;
	hr	= pKeystrokeMgr->PreserveKey (m_tfClientId, c_guidSkkImePreservedKeyToggleIME, &key, wstrDesc, lstrlenW (wstrDesc)) ;
	/*	register ALT+~ key */
	key.uVKey		= 0xC0 ;
	key.uModifiers	= TF_MOD_ALT ;
	hr	= pKeystrokeMgr->PreserveKey (m_tfClientId, c_guidSkkImePreservedKeyToggleIME, &key, wstrDesc, lstrlenW (wstrDesc)) ;
    pKeystrokeMgr->Release () ;

	DEBUGPRINTF ((TEXT ("_InitPreservedKey () = %d\n"), (hr == S_OK))) ;
	return	(hr == S_OK) ;
}

/*	_UninitPreservedKey
 *
 *	o^ Hot Key 𖢓o^Ԃɖ߂B
 */
void
CSkkImeTextService::_UninitPreservedKey ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	TF_PRESERVEDKEY		key ;

	if (m_pThreadMgr == NULL)
		return ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return ;

	key.uVKey		= VK_KANJI ;
	key.uModifiers	= TF_MOD_IGNORE_ALL_MODIFIER ;
	pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyToggleIME, &key) ;
	key.uVKey		= 0xC0 ;
	key.uModifiers	= TF_MOD_ALT ;
	pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyToggleIME, &key) ;
	pKeystrokeMgr->Release () ;
	return ;
}

/*	OnSetFocus
 *
 *	̃T[rX keystroke device focus 𓾂͏ɃVXeɂ
 *	ĂяoB
 *	܂́AꂪAOnTestKeyDown Ă΂oƍlč\Ȃ
 *	낤B
 */
STDAPI
CSkkImeTextService::OnSetFocus (
	BOOL			fForeground)
{
    return	S_OK ;
	UNREFERENCED_PARAMETER (fForeground) ;
}

/*	OnTestKeyDown
 *
 *	̃T[rX^ꂽ potential keystroke ~邩ۂ
 *	q˂邽߂ɃVXeɂČĂяoB(A)
 *
 *	ŁAL[Xg[N~AƕԂ΁AOnKeyDown Ăяo
 *	邱ƂɂȂB
 */
STDAPI
CSkkImeTextService::OnTestKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
	int		nEaten ;
	DWORD	dwKeyMask ;
	BOOL	bEaten ;

	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (w:0x%0x, l:0x%0x)\n"), (DWORD)wParam, (DWORD)lParam)) ;
	if (_IsKeyboardDisabled ()) {
		*pfEaten	= FALSE ;
		DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (fEaten: %d)\n"), *pfEaten)) ;
		return	S_OK ;
	}

	/*	xkeymacs  foward  event  context bit  1 Ă悤ɎvB
	 *	 key  process Ɣ肷ƁAǂ PowerPoint Ȃǂ \C-x\C-s Ȃǂ
	 *	삪܂Ȃ炵BWord ŔoȂ̂́AWord  context bit 𔻕ʂĂ
	 *	̂낤cH (Wed Feb 15 20:28:29 2006)
	 */
	if (lParam & ((DWORD)1 << 29)) {
		*pfEaten	= FALSE ;
		return	S_OK ;
	}

	dwKeyMask	= 0 ;
	dwKeyMask	|= (GetKeyState (VK_LCONTROL) & 0x8000)?	KEYMASK_LCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RCONTROL) & 0x8000)?	KEYMASK_RCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LMENU)    & 0x8000)?	KEYMASK_LMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RMENU)    & 0x8000)?	KEYMASK_RMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LSHIFT)   & 0x8000)?	KEYMASK_LSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RSHIFT)   & 0x8000)?	KEYMASK_RSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_SCROLL)   & 0x8000)?	KEYMASK_SCROLL		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_NUMLOCK)  & 0x8000)?	KEYMASK_NUMLOCK		: 0 ;

	nEaten		= m_pSkkIme->QueryProcessKey (wParam, lParam, dwKeyMask) ;
	bEaten		= (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) || (nEaten == SKKIME_PROCESS_KEY && _IsKeyboardOpen ()) ;
	*pfEaten	= bEaten ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
}

/*	OnKeyDown
 *
 *	Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 *	on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N񋟂邽
 *	ɌĂяoBA*pfEaten == TRUE ŁA OnKeyDown 
 *	oAAvP[V͂̃L[Xg[N
 *	B(ۂɃL[Hׂ邩ǂ̔͒xłAƂ
 *	)
 */
STDAPI
CSkkImeTextService::OnKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    CKeystrokeEditSession*	pEditSession ;
    HRESULT					hr ;
	DWORD					dwKeyMask ;
	int						nEaten ;

	hr			= S_FALSE ;
    *pfEaten	= FALSE ;

    if (!m_pSkkIme || _IsKeyboardDisabled ())
		goto	Exit ;
	if (m_pThreadMgr == NULL)
		goto	Exit ;

	/*	WordPad  OnTestKeyDown oRɒ OnKeyDown ɓ̂ŁA
	 *	OnTestKeyDown  KeyMask mۂłƍl邱Ƃ͂łȂB
	 *	Ă΂xɋ߂KvB
	 */
	dwKeyMask	= 0 ;
	dwKeyMask	|= (GetKeyState (VK_LCONTROL) & 0x8000)?	KEYMASK_LCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RCONTROL) & 0x8000)?	KEYMASK_RCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LMENU)    & 0x8000)?	KEYMASK_LMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RMENU)    & 0x8000)?	KEYMASK_RMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LSHIFT)   & 0x8000)?	KEYMASK_LSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RSHIFT)   & 0x8000)?	KEYMASK_RSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_SCROLL)   & 0x8000)?	KEYMASK_SCROLL		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_NUMLOCK)  & 0x8000)?	KEYMASK_NUMLOCK		: 0 ;

	nEaten	= m_pSkkIme->QueryProcessKey (wParam, lParam, dwKeyMask) ;
	if (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) {
		ITfKeystrokeMgr*	pKeystrokeMgr	= NULL ;

		if (FAILED (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr)))
			goto	Exit ;
		hr	= pKeystrokeMgr->SimulatePreservedKey (pContext, c_guidSkkImePreservedKeyToggleIME, pfEaten) ;
		pKeystrokeMgr->Release () ;
	} else if (_IsKeyboardOpen () && nEaten == SKKIME_PROCESS_KEY) {
		HRESULT	hrEaten	= S_FALSE ;

		/*	ۂɕ̃L[Xg[N̂ꏊɁuŁv
		 *	}KvB
		 *	ǂ̕邩́A̎̎BȂA
		 *	IƃL[Xg[N͏ƂɂȂ̂ȁB
		 *
		 *	̑} CKeystrokeEditSession::DoEditSession 
		 *	ǊB
		 */
		pEditSession = new CKeystrokeEditSession (pContext, wParam, lParam, dwKeyMask, m_pSkkIme) ;
        if (pEditSession == NULL) {
            hr	= E_OUTOFMEMORY ;
            goto	Exit ;
        }
		
		/*	u}vȂǂ̏s߂ɂ̓bNK
		 *	v(炵)B=> we need a lock to do our work
		 *
		 *	nb:  method  TF_ES_SYNC tOgƂ legal
		 *		ށAH@Hȏꏊ1łB
		 *	ȂA SYNC AƂƂB
		 */
		hr	= pContext->RequestEditSession(m_tfClientId, pEditSession, TF_ES_SYNC | TF_ES_READWRITE, &hrEaten) ;
        if (FAILED (hr)) 
            hrEaten	= S_OK ;
        pEditSession->Release () ;

		/*	̃R[h *pfEaten = FALSE ɂĕԂĂ key 
		 *	handle ĂȂꍇ̂߂ code c
		 *	ƂAhandle ȂłǁH > IE ȂǁB
		 *	̂ŁA*pfEaten = TRUE ɂĂAI keyevent
		 *	Ă݂B
		 *	bZ[W[vȂ悤ɒӁB
		 */
		if (SUCCEEDED (hr) && hrEaten == S_FALSE) {
			INPUT	in ;
			WORD	woScanCode	= (WORD)(lParam >> 16) ;

#if defined (DEBUGLOGFILE_ENABLE)
			vDebugPrintfToFile (TEXT ("[%d] CSkkImeTextService -> SendInput (wVK:0x%0x, wScan:0x%0x)\r\n"), 
				GetTickCount (), wParam, lParam) ;
#endif
			memset (&in, 0, sizeof (in)) ;
			in.type				= INPUT_KEYBOARD ;
			in.ki.wVk			= wParam ;
			in.ki.wScan			= woScanCode & 0x007F ;
			in.ki.dwFlags		= KEYEVENTF_SCANCODE ;
			if ((woScanCode & 0xFF00) == 0xE000)
				in.ki.dwFlags	|= KEYEVENTF_EXTENDEDKEY ;
			in.ki.time			= GetTickCount () ;
			in.ki.dwExtraInfo	= NULL ;
			SendInput (1, &in, sizeof (in)) ;
		}
	}
Exit:
    if (hr == S_OK) 
        *pfEaten = TRUE ;

	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnKeyDown (Eaten:%d)\n"), *pfEaten)) ;
    return S_OK;
}

/*	DoEditSession
 */
STDAPI
CKeystrokeEditSession::DoEditSession (
	TfEditCookie		ec)
{
    WCHAR	wc ;
	BOOL	fEaten	= FALSE ;
	HRESULT	hr ;

	DEBUGPRINTF ((TEXT ("CKeyStrokeEditSession::DoEditSession ()\n"))) ;

	/*	ƂƂ CaseTextService ł́A 
	 *	if (GetKeyState(VK_SHIFT) & 0x8000) {
	 *		// shift-key, make it lowercase
	 *		wc	= (WCHAR)(m_wParam | 32) ;
	 *	} else {
	 *		// else make it capital
	 *		wc	= (WCHAR)m_wParam ;
	 *	}
	 *	ƂsĂB́AꂽL[
	 *	(ܘ_AplĂ̂A
	 *	ɗ܂łɑ삳Ă)
	 *	 case ϊ̂łB
	 *	nb:	 quick-and-dirty R[hł邪A
	 *		啶 flip 邽߂̐
	 *		@邽߂̃R[hȂA
	 *	AȂقǁB
	 */
	wc	= (WCHAR)m_wParam ;
	hr	= m_pSkkIme->OnEditSession (m_pContext, ec, WM_KEYDOWN, wc, m_lParam, m_dwMask, &fEaten) ;
	if (FAILED (hr)) {
		DEBUGPRINTF ((TEXT ("m_pSkkIme->OnEditSession failed.\n"))) ;
		return	hr ;
	}
	if (hr == S_FALSE) 
		fEaten	= FALSE ;
    return	(fEaten)? S_OK : S_FALSE ;
}

/*	OnTestKeyUp
 *
 *	̃T[rX potentiaon L[Xg[N~邩ǂ
 *	₢킹邽߂ɃVXeɂČĂяoB
 *
 *	 Eaten Ԃ΁A OnKeyUp Ăяo邱
 *	ɂȂBƂAImeProcess ̂悤 KeyUp HׂĂ͂
 *	ƂƂ͖BƂ́Aނ Up/Down 
 *	΂ɂĈȂ΂ȂȂH
 */
STDAPI
CSkkImeTextService::OnTestKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
	UNREFERENCED_PARAMETER (wParam) ;
	UNREFERENCED_PARAMETER (lParam) ;
}

/* OnKeyUp
 *
 * Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 * on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N^邽߂ɌĂяoB
 *	A*pfEaten == TRUE  exit Ȃ΁AAvP[V͂̃L[Xg
 *	[NȂB
 */
STDAPI
CSkkImeTextService::OnKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
	UNREFERENCED_PARAMETER (wParam) ;
	UNREFERENCED_PARAMETER (lParam) ;
}

/*	OnPreservedKey
 *
 *	Called when a hotkey (registered by us, or by the system) is typed.
 *	hotkey  type ꂽɌĂяoB(Ȃق)
 */
STDAPI
CSkkImeTextService::OnPreservedKey (
	ITfContext*		pContext,
	REFGUID			rguid,
	BOOL*			pfEaten)
{
	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnPreservedKey ()\n"))) ;

	/*	CaseTextService ͎̂悤ȃR[hɂȂĂB
	 *	ǂ PreservedKey 𔻒肷ɂ GUID g
	 *	ɂȂ悤B
	 *
	 *	if (IsEqualGUID (rguid, GUID_PRESERVEDKEY_FLIPCASE)) {
	 *		_Menu_FlipDoc (this) ;
	 *		*pfEaten	= TRUE ;
	 *	} else {
	 *		*pfEaten	= FALSE ;
	 *	}
	 *
	 *	Ȃ݂ɁA
	 *	void CCaseTextService::_Menu_FlipKeys(CCaseTextService *_this)
	 *	{
	 *		_this->_fFlipKeys = !_this->_fFlipKeys;
	 *	}
	 *
	 *	 _Menu_FlipKeys ̎ԂłBǂ Menu ̕\
	 *	QƂ郁oϐ𑀍삷邾̂悤B
	 *	j[\̂H!Ƃv̂A̕@
	 *	ŒׂKv邩ȁB
	 */
	/*
	if (IsEqualGUID (rguid, CSkkImeTextService::_GUID_PRESERVEDKEY_TOGGLEIME)) {
		m_pSkkIme->SetFilterMode (! m_pSkkIme->GetFilterMode ()) ;
		*pfEaten	= TRUE ;
	} else {
		*pfEaten	= FALSE ;
	}
	*/
	if (IsEqualGUID (rguid, c_guidSkkImePreservedKeyToggleIME)) {
	    CToggleImeEditSession*	pEditSession ;
		HRESULT	hr, hrEaten ;

		pEditSession = new CToggleImeEditSession (pContext, m_pSkkIme) ;
		if (pEditSession == NULL) 
			return	E_OUTOFMEMORY ;
		
		hr	= pContext->RequestEditSession(m_tfClientId, pEditSession, TF_ES_SYNC | TF_ES_READWRITE, &hrEaten) ;
        if (FAILED (hr)) 
            hrEaten	= S_OK ;
        pEditSession->Release () ;
//		_SetKeyboardOpen (fOpen? FALSE : TRUE) ;
//		m_pSkkIme->OnKeyboardOpen (!fOpen) ;
		*pfEaten	= TRUE ;
	} else {
		*pfEaten	= FALSE ;
	}
    return	S_OK ;
}


STDAPI
CToggleImeEditSession::DoEditSession (
	TfEditCookie		ec)
{
	HRESULT	hr ;

	DEBUGPRINTF ((TEXT ("CToggleImeEditSession::DoEditSession ()\n"))) ;

	hr	= m_pSkkIme->OnToggleImeSession (m_pContext, ec) ;
	if (FAILED (hr)) {
		DEBUGPRINTF ((TEXT ("m_pSkkIme->OnToggleImeSession failed.\n"))) ;
		return	hr ;
	}
	return	S_OK ;
}



