/*	\[gĂ炸Ao^ȂACompletion ɂgȂA
 *	ʂ̎B
 */
#include "local.h"
#include "jisyo.h"
#include "genericjisyo.h"
#include "cstring.h"
#include "kstring.h"
#include "kfile.h"

#define	OKURIARI_STR	";; okuri-ari entries."
#define	OKURINASI_STR	";; okuri-nasi entries."

#define	TEXTBUFSIZE	(1024)

/*	Private Prototypes	*/
static	BOOL	skkGenericJisyo_search		(SkkJisyo*, const Char*, int, const Char*, int, int, TVarbuffer*) ;
static	BOOL	skkGenericJisyo_destroy		(SkkJisyo*) ;
static	LPCTSTR	skkGenericJisyo_getPath		(SkkJisyo*) ;

static	BOOL	skkGenericJisyo_searchWithFileptr	(KFILE*, const Char*, int, BOOL, TVarbuffer*) ;

/*	VTBL
 */
static SkkJisyoFunc		sGenericJisyoProcTbl	= {
	skkGenericJisyo_search,
	NULL,
	NULL,
	NULL,
	NULL,
	skkGenericJisyo_destroy,
	skkGenericJisyo_getPath,
} ;

/*
 *	w肳ꂽpX̎w肳ꂽ@Ƃēo^֐B
 */
SkkJisyo*
SkkGenericJisyo_Create (
	register const Char*	pFileName,
	register int			nFileName)
{
	TCHAR		strPath [PATH_MAX + 1] ;
	register SkkJisyo*			pJisyo ;
	register SkkGenericJisyo*	pGenericJisyo ;

	if (nFileName > PATH_MAX)
		return	NULL ;

#if defined (UNICODE)
	internal2wstr (strPath, ARRAYSIZE (strPath) - 1, pFileName, nFileName) ;
#else
	cstrtostr (strPath, pFileName, nFileName) ;
#endif
	strPath [nFileName]		= '\0' ;

	/* t@CǗ邽߂̃f[^̈mۂB*/
	pJisyo	= MALLOC (sizeof (SkkJisyo) + sizeof (SkkGenericJisyo)) ;
	if (pJisyo == NULL)
		return	NULL ;

	pJisyo->m_pVtbl	= &sGenericJisyoProcTbl ;
	pGenericJisyo	= (SkkGenericJisyo*) (pJisyo + 1) ;
#if __STDC_WANT_SECURE_LIB__
	_tcsncpy_s (pGenericJisyo->m_tszPath, ARRAYSIZE (pGenericJisyo->m_tszPath), strPath, PATH_MAX) ;
#else
	_tcsncpy (pGenericJisyo->m_tszPath, strPath, PATH_MAX) ;
#endif
	pGenericJisyo->m_tszPath [PATH_MAX]	= TEXT ('\0') ;
	/*pGenericJisyo->m_nCodingSystem	= KCODING_SYSTEM_UNKNOWN ;*/
	return	pJisyo ;
}

/*
 *	w肳ꂽpX̎w肳ꂽ@Ƃēo^֐B
 */
SkkJisyo*
SkkGenericJisyo_CreateT (
	register LPCTSTR		pFileName)
{
	register SkkJisyo*			pJisyo ;
	register SkkGenericJisyo*	pGenericJisyo ;
	register int				nFileName ;

	if (pFileName == NULL)
		return	NULL ;
	nFileName	= lstrlen (pFileName) ;
	if (nFileName >= PATH_MAX)
		return	NULL ;

	/* t@CǗ邽߂̃f[^̈mۂB*/
	pJisyo	= MALLOC (sizeof (SkkJisyo) + sizeof (SkkGenericJisyo)) ;
	if (pJisyo == NULL)
		return	NULL ;

	pJisyo->m_pVtbl	= &sGenericJisyoProcTbl ;
	pGenericJisyo	= (SkkGenericJisyo*) (pJisyo + 1) ;
	lstrcpy (pGenericJisyo->m_tszPath, pFileName) ;
	/*pGenericJisyo->m_nCodingSystem	= KCODING_SYSTEM_UNKNOWN ;*/
	return	pJisyo ;
}

/*========================================================================
 *	g̑B
 *========================================================================*/
BOOL
skkGenericJisyo_search (
	SkkJisyo*		pSkkJisyo,
	const Char*		pKey,
	int				nKey,
	const Char*		pOkurigana,
	int				nOkurigana,
	int				nOkuriType,
	TVarbuffer*		pvbuf)
{
	SkkGenericJisyo*	pJisyo	= (SkkGenericJisyo*)(pSkkJisyo + 1) ;
	KFILE				kf ;
	BOOL	fResult ;

	assert (pJisyo != NULL) ;

	/* JBJȂAG[B*/
	if (TFAILED (KFile_Open (&kf, pJisyo->m_tszPath, -1)))
		return	TRUE ;
	fResult	= skkGenericJisyo_searchWithFileptr (&kf, pKey, nKey, nOkuriType != SEARCH_OKURI_NASHI, pvbuf) ;
	KFile_Close (&kf) ;
	return	TRUE ;
	UNREFERENCED_PARAMETER (pOkurigana) ;
	UNREFERENCED_PARAMETER (nOkurigana) ;
}

BOOL
skkGenericJisyo_destroy (
	register SkkJisyo*			pSkkJisyo)
{
	FREE (pSkkJisyo) ;
	return	TRUE ;
}

LPCTSTR
skkGenericJisyo_getPath	(
	register SkkJisyo*			pSkkJisyo)
{
	register SkkGenericJisyo*	pJisyo	= (SkkGenericJisyo*)(pSkkJisyo + 1) ;

	return	pJisyo->m_tszPath ;
}

/*========================================================================
 *	private functions
 */
BOOL
skkGenericJisyo_searchWithFileptr (
	register KFILE*			pFile,
	register const Char*	pKey,
	register int			nKey,
	register BOOL			fOkuri,
	register TVarbuffer*	pvbuf)
{
	Char					szBuffer [TEXTBUFSIZE] ;
	register const Char*	ptr ;
	register int			nptr ;
	register Char*			pDest ;
	register int			nDest ;
	register Char			cc, chPrev ;
	register BOOL			fFound, fResult, bDuringAnnotation ;

	if (pFile == NULL || pKey == NULL || nKey <= 0 || Char_IsNul (*pKey))
		return	TRUE ;

	KFile_Rewind (pFile) ;
	if (fOkuri){
		fResult	= KFile_FindsAtBeginningOfLineA (pFile, OKURIARI_STR) ;
	} else {
		fResult	= KFile_FindsAtBeginningOfLineA (pFile, OKURINASI_STR) ;
	}
	if (TFAILED (fResult))
		return	FALSE ;
	if (TFAILED (KFile_Nextline (pFile)))
		return	FALSE ;

	fFound		= FALSE ;
	ptr			= NULL ;
	for ( ; ; ){
		cc		= KFile_Getc (pFile) ;
		if (cc != ';') {
			ptr		= pKey ;
			nptr	= nKey ;
			while (cc != EOF && cc != '\n' && cc != '\r' && nptr > 0) {
				if (! Char_IsEqual (cc, *ptr))
					break ;
				cc	= KFile_Getc (pFile) ;
				ptr		++ ;
				nptr	-- ;
			}
			if (nptr == 0) {
				if (! Char_DifferenceAscii (cc, ' ')) {
					/* ̏ꍇɂ͌񂪃qbgƂɂȂB*/
					fFound	= TRUE ;
					break ;
				}
			}
		} else {
			register const char*	aptr ;
			
			/* āA艼Gg܂ŗĂ܂̂H*/
			aptr	= (fOkuri)? OKURINASI_STR : OKURIARI_STR ;
			while (*aptr != '\0' && !Char_DifferenceAscii (cc, *aptr)) {
				aptr	++ ;
				cc	= KFile_Getc (pFile) ;
			}
			/* ȏ̃Gg邱Ƃ͖B*/
			if (*aptr == '\0' && cc == '\n')
				cc	= (Char) EOF ;
		}
		/* s܂œǂݔ΂B*/
		while (cc != EOF && cc != '\n' && cc != '\r')
			cc	= KFile_Getc (pFile) ;
		/* t@C̍ŌɗĂꍇɂ͌IB*/
		if (cc == EOF)
			break ;
	}
	/* Ȃꍇɂ͉ȂB*/
	if (TFAILED (fFound))
		return	TRUE ;

	while (cc = KFile_Getc (pFile), ! Char_DifferenceAscii (cc, ' '))
		;

	/*	c̕ϒobt@ɒ@ށB*/
	pDest				= szBuffer ;
	nDest				= ARRAYSIZE (szBuffer) ;
	bDuringAnnotation	= FALSE ;
	chPrev				= cc ;
	while (cc != EOF && cc != '\n' && cc != '\r') {
		/* auto-okuri ̒EoB*/
		if (fOkuri && ! bDuringAnnotation && Char_DifferenceAscii (chPrev, '/') == 0 && Char_DifferenceAscii (cc, '[') == 0) 
			break ;
		if (Char_DifferenceAscii (cc, '/') == 0) 
			bDuringAnnotation	= FALSE ;
		if (Char_DifferenceAscii (cc, ';') == 0)
			bDuringAnnotation	= TRUE ;
		if (nDest == 0) {
			TVarbuffer_Add (pvbuf, szBuffer, ARRAYSIZE (szBuffer)) ;
			pDest	= szBuffer ;
			nDest	= ARRAYSIZE (szBuffer) ;
		}
		*pDest	++	= cc ;
		nDest	-- ;
		chPrev		= cc ;
		cc			= KFile_Getc (pFile) ;
	}
	if (nDest != ARRAYSIZE (szBuffer))
		TVarbuffer_Add (pvbuf, szBuffer, ARRAYSIZE (szBuffer) - nDest) ;
	return	TRUE ;
}

