#if !defined (kanji_h)
#define	kanji_h

#include "local.h"
#include "charset.h"
#include "Char.h"

/*========================================================================*
 *	L萔B
 *========================================================================*/
/*
 *	R[fBOVXeB
 */
enum {
	KCODING_SYSTEM_UNKNOWN		= -1,
	KCODING_SYSTEM_EUCJP		= 0,
	KCODING_SYSTEM_ISO2022JP2,
	KCODING_SYSTEM_SHIFTJIS,
	KCODING_SYSTEM_COMPOUND_TEXT,
	KCODING_SYSTEM_UNICODE,
	KCODING_SYSTEM_BINARY,
	MAX_KCODING_SYSTEM,
} ;

/*
 *	sR[hB
 */
enum {
	KNEWLINE_UNKNOWN	= -1,
	KNEWLINE_UNIX		= 0,	/* 0x0A */
	KNEWLINE_MSDOS,				/* 0x0D 0x0A */
	KNEWLINE_MAC,				/* 0x0D */
} ;

/*========================================================================*
 *	}N̒`B
 *========================================================================*/

#define IS_SHIFTJIS_2BYTE_CODE1(c)		(((((unsigned char)c) >= 0x81 && ((unsigned char)c) <= 0x9F) || (((unsigned char)c) >= 0xE0 && ((unsigned char)c) <= 0xEF))? TRUE : FALSE)
#define IS_SHIFTJIS_2BYTE_CODE2(c)		(((((unsigned char)c) >= 0x40 && ((unsigned char)c) <= 0x7E) || (((unsigned char)c) >= 0x80 && ((unsigned char)c) <= 0xFC))? TRUE : FALSE)
#define IS_SHIFTJIS_JISX201_KATAKANA(c)	((((unsigned char)c) >= 0xA1 && ((unsigned char)c) <= 0xDF)? TRUE : FALSE)

#define	KANJICODE_CODINGSYSTEM(kcode)	((short)(kcode & 0x0000FFFFl))
#define	KANJICODE_NEWLINETYPE(kcode)	(((short)(kcode >> 16) & 0x0000FFFFl))
#define	KANJICODE_MAKE(iCS,iNT)			((KANJICODE)((((unsigned long)iCS) & 0x0000FFFFl) | ((((unsigned long)iNT) & 0x0000FFFFl) << 16)))


/*========================================================================*
 *	^`B
 *========================================================================*/

/*========================================================================*
 *	\́B
 *========================================================================*/
/*
 *	ISO2022 ͏ԑJڋ@B́uԁv
 */
typedef struct tagISO2022STATE {
	BOOL		m_fEscapeSequence ;
	int			m_iEscapeState ;
	BOOL		m_fSingleShift ;
	int			m_iLeadChara ;
	int			m_iCharset [4] ;
	int			m_iGL [2] ;
	int			m_iGR [2] ;
}	ISO2022STATE, *PISO2022STATE ;

/*
 *	Microsoft R[h͏ԋ@B́uԁv
 */
typedef struct tagSHIFTJISSTATE {
	int			m_iLeadChara ;
}	SHIFTJISSTATE, *PSHIFTJISSTATE ;

/*
 *	CompoundText ͏ԑJڋ@B́uԁv
 */
typedef struct tagCTEXTSTATE {
	BOOL		m_fEscapeSequence ;
	int			m_iEscapeState ;
	BOOL		m_fSingleShift ;
	int			m_iLeadChara ;
	int			m_nGL ;
	int			m_nGR ;
}	CTEXTSTATE, *PCTEXTSTATE ;

typedef struct tagUNICODESTATE {
	WCHAR		m_wFirstChara ;
	BOOL		m_fSecondByte ;
}	UNICODESTATE, *PUNICODESTATE ;

/*
 *	R[h͂̂߂̏ԑJڋ@BB
 */
typedef struct tagKANJISTATEMACHINE {
	/*	ďBsɂčďꍇɎgB*/
	int			(*m_pRestartFunc)(struct tagKANJISTATEMACHINE*) ;

	/*	R[hɕϊ鎞ɎguJځv֐B*/
	int			(*m_pTransferFunc)(struct tagKANJISTATEMACHINE*, int iChara, Char* pOutput) ;

	/*	R[hϊ鎞ɎguJځv֐B*/
	int			(*m_pRtransferFunc)(struct tagKANJISTATEMACHINE*, Char cc, char* pOutput) ;

	/*	ԁBƂēR[hɕϊ鎞ɗpB*/
	union {
		ISO2022STATE	m_iso2022 ;
		SHIFTJISSTATE	m_shiftjis ;
		CTEXTSTATE		m_ctext ;
		UNICODESTATE	m_unicode ;
	}	m_state ;

}	KANJISTATEMACHINE, *PKANJISTATEMACHINE ;

/*========================================================================*
 *	vg^Cv錾B
 *========================================================================*/
int		DetectKanjiCodingSystem				(const char* pBytes, int nBytes, int* pNewlineType) ;
int		InitializeKanjiFiniteStateMachine 	(PKANJISTATEMACHINE pKSM, int iCodingSystem) ;
int		RestartKanjiFiniteStateMachine		(PKANJISTATEMACHINE pKSM) ;
int		TransferKanjiFiniteStateMachine		(PKANJISTATEMACHINE pKSM, int iChara, Char* pOutput) ;
int		RtransferKanjiFiniteStateMachine	(PKANJISTATEMACHINE pKSM, Char cc, char* pOutput) ;

#endif

