#include "local.h"
#include <assert.h>
#include "kstring.h"
#include "kanji.h"

/*	ᑬ unicode 񂩂R[hւ̕ϊ֐F
 *		ꕶ unicode  wcstombs  multibyte ɕϊ
 *		ꂩR[hɒB
 *		(unicode  table 邵ȂAOS ̕WȊO table 
 *		 ̂ memory  & unicode.org ͔̂ɂĂ
 *		 ߁Ał͂Ȃ)
 *		multibyte ɒȂꍇɂ́Aunicode ̂܂܂Ƃ
 *		Ĉ (charset = unicode ƌŒ肳)B
 */
int
wstr2internal (
	register Char*		pDest,
	register int		nDest,
	register LPCWSTR	pSource,
	register int		nSource)
{
	wchar_t				rwbuf [2] ;
	char				rcbuf [16] ;
	register int		nDestBack, n ;
	KANJISTATEMACHINE	ksm ;
	Char				ch ;

	nDestBack	= nDest ;
	rwbuf [1]	= L'\0' ;
	InitializeKanjiFiniteStateMachine (&ksm, KCODING_SYSTEM_SHIFTJIS) ;
	while (nSource > 0 && nDest > 0) {
		rwbuf [0]	= *pSource ++ ;
		nSource	-- ;

		/*	ꕶϊB Unicode ̓A߂Ȃ
		 *	charset  unicode ̂܂܂ɂ邩B
		 */
		n	= WideCharToMultiByte (CP_OEMCP, 0, rwbuf, 1, rcbuf, ARRAYSIZE (rcbuf), NULL, NULL) ;
		if (n <= 0) {
			/*	ϊɎsꍇɂ́AUnicode ̂܂܂ňB*/
			*pDest ++	= Char_Make (KCHARSET_UNICODE, rwbuf [0]) ;
			nDest -- ;
		} else {
			register const char*	ptr ;

			ptr	= rcbuf ;
			while (n > 0 && nDest > 0) {
				if (TSUCCEEDED (TransferKanjiFiniteStateMachine (&ksm, *ptr ++, &ch))) {
					*pDest	++	= ch ;
					nDest	-- ;
				}
				n	-- ;
			}
			/*	R[hϊԋ@BďB*/
			RestartKanjiFiniteStateMachine (&ksm) ;
		}
	}
	return	(nDestBack - nDest) ;
}

int
internal2wstr (
	register LPWSTR			pwDest,
	register int			nDest,
	register const Char*	pSrc,
	register int			nSrc)
{
	KANJISTATEMACHINE		ksm ;
	unsigned char			rbuf [16] ;
	register int			nDestBack, n ;

	InitializeKanjiFiniteStateMachine (&ksm, KCODING_SYSTEM_UNICODE) ;
	nDestBack	= nDest ;
	while (nSrc > 0 && nDest > 0) {
		n	= RtransferKanjiFiniteStateMachine (&ksm, *pSrc ++, (char*)rbuf) ;
		/*	ꕶĂȂ̂ŁA0  2 2肦ȂB*/
		if (n == 2) {
			*pwDest	++ = (((unsigned short)rbuf [1]) << 8) | (unsigned short)rbuf [0] ;
		} else {
			/*	s\Ȍʂ߂ɂ́uvɒuB*/
			*pwDest ++	= L'' ;
		}
		nDest -- ;
		nSrc  -- ;
	}
	return	(nDestBack - nDest) ;
}

BOOL
internalStringContainsUnicodeCharp (
	register const Char*	pString,
	register int			nString)
{
	while (nString > 0 && Char_Charset (*pString) != KCHARSET_UNICODE) {
		pString	++ ;
		nString	-- ;
	}
	return	(nString > 0) ;
}



