/* # SKKIME'98 (Simple Kana-Kanji Input Method Editor for Windows'98)
 * Config.c
 * This file is part of skkime'98.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "skki1_5.h"
#include "shlwapi.h"
#include "winfile.h"
#include "resource.h"
#include "ImeConfig.h"

/*========================================================================
 *	definitions
 */
#define	PROGRAMF_DIR			L"IME"
#define	SKKIMEProg_S_DIR		L"SKKIM15"
#define	SKKIMEServerFile		L"skkiserv.exe"

/*========================================================================
 *	static global variables:
 */
static	BOOL			s_bSkkImeHideToolbar ;

/*************************************************************************
 *	ImeConfigure
 *		ImeConfigure ֐ IME ɑ΂ĕ⑫Iȏv邽߂Ɏg
 *		Dialog Box 񋟂H
 *	BOOL
 *		ImeConfigure(
 *		HKL hKL,
 *		HWND hWnd,
 *		DWORD dwMode,
 *		LPVOID lpData
 *		)
 *	Parameters
 *		hKL
 *			 IME ̓͌̃nhB
 *		hWnd
 *			e Window ̃nhB
 *		dwMode
 *			Dialog ̃[hBȉ̂悤ȃtO^B
 *			IME_CONFIG_GENERAL			 configuration ̂߂ Dialog
 *			IME_CONFIG_REGWORD			Po^̂߂ Dialog
 *			IME_CONFIG_SELECTDICTIONARY	IME Î߂ Dialog
 *		lpData
 *			VOID ^̃|C^B dwMode == IME_CONFIG_REGISTERWORD ȂA
 *			REGISTERWORD \̂ւ̃|C^ƂȂBȂΖB
 *			initial string ^ȂAIME_CONFIG_REGISTER [h
 *			łĂANULL łĂ܂ȂB
 *		Return Values
 *			̊֐ATRUEBȂ FALSEB
 *	Comments
 *		IME ͎̂悤ȋ[R[hł lpData `FbNB
 *
 *	if (dwmode != IME_CONFIG_REGISTERWORD){
 *		// Does original execution
 *	} else if (IsBadReadPtr(lpdata, sizeof(REGISTERWORD))==FALSE){
 *		if (IsBadStringPtr(PREGISTERWORD(lpdata)->lpReading, (UINT)-1)==FALSE){
 *			// Set the reading string to word registering dialogbox
 *		}
 *		if (IsBadStringPtr(PREGISTERWORD(lpdata)->lpWord, (UINT)-1)==FALSE){
 *			// Set the word string to word registering dialogbox
 *		}
 *	}
 *************************************************************************/
BOOL	WINAPI
ImeConfigure (HKL hKL, HWND hWnd, DWORD dwMode, LPVOID lpData)
{
	WCHAR					rszWindowsDir [MAX_PATH + 1] ;
	WCHAR					rszCmd [MAX_PATH + 1] ;
    STARTUPINFOW			si ;
    PROCESS_INFORMATION		pi ;
	int						nWindowsDir, n ;
	BOOL					fRetval ;

	/*	Secure Session Ȃ Config ͎sĂ͂ȂȂB*/
	if (g_bSkkImeSecure)
		return	FALSE ;

	if (dwMode != IME_CONFIG_REGISTERWORD) {
		nWindowsDir	= GetWindowsDirectoryW (rszWindowsDir, ARRAYSIZE (rszWindowsDir) - 1) ;
		rszWindowsDir [nWindowsDir]		= L'\0' ;
		n			= wnsprintf (rszCmd, ARRAYSIZE (rszCmd) - 1, L"%s" L"\\" PROGRAMF_DIR L"\\" SKKIMEProg_S_DIR L"\\" SKKIMEConfigProg, rszWindowsDir) ;
		rszCmd [n]	= L'\0' ;

		ZeroMemory (&si, sizeof(si)) ;
		si.cb	= sizeof (si) ;
		if (! CreateProcessW (rszCmd, L"", NULL, NULL, FALSE, 0, NULL, rszWindowsDir, &si, &pi)) {
			fRetval	= FALSE ;
		} else {
			/* ҂ȂB(void) WaitForSingleObject (pi.hProcess, INFINITE) ;*/
			/* svɂȂnhB*/
			CloseHandle (pi.hProcess) ;
			CloseHandle (pi.hThread) ;
			fRetval	= TRUE ;
		}
	} else {
		/* Po^̃_CAOĂяo悤ɂȂ΁cB*/
		fRetval	= FALSE ;
	}
	return	fRetval ;
}

BOOL
TSkkIme_bIsHideToolbarp (void)
{
#if !defined (NO_TOUCH_REGISTRY)
	DWORD	dwValue	;
#if !defined (NO_TSF)
	if (bTSF_IsTSFEnabled ()) 
		return	TRUE ;
#endif
	if (GetRegDwordValue (TEXT ("\\Window"), TEXT(REGKEY_HIDETOOLBAR), &dwValue))
		return	(dwValue != 0) ;
	return	FALSE ;
#else
	return	TRUE ;
#endif
}

void
TSkkIme_vUpdateConfig (
	HIMC			hIMC)
{
	LPINPUTCONTEXT	lpIMC ;

	lpIMC	= ImmLockIMC (hIMC) ;
	if (lpIMC == NULL)
		return ;
	if (ImmGetIMCCSize (lpIMC->hCompStr) < sizeof (MYCOMPSTR))
		goto	exit_func ;

	ImeConfig_vUpdate () ;
exit_func:
	ImmUnlockIMC (hIMC) ;
	return ;
}

