/* # SKKIME1.0 (Simple Kana-Kanji Input Method Editor for Windows2000)
 * immntfy.c
 * This file is part of skkime1.0.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "skki1_5.h"
#include "resource.h"
#include "ImeConfig.h"

/*
 *	vg^Cv錾B
 */
static	BOOL	tSkkIme_bOnNotifyContextUpdated		(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyCompositionStr		(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyOpenCandidate		(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyCloseCandidate		(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifySelectCandidateStr	(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyChangeCandidateList	(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifySetCandidatePageSize	(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifySetCandidatePageStart	(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyFinalizeConversionResult(HIMC, DWORD, DWORD, DWORD) ;
static	BOOL	tSkkIme_bOnNotifyImeMenuSelected		(HIMC, DWORD, DWORD, DWORD) ;

/***********************************************************************
 *	NotifyIME
 *	NotifyIME ֐͗^ꂽp[^ɏ] IME ̏ԂύXB
 *	BOOL
 *		NotifyIME(
 *		HIMC hIMC,
 *		DWORD dwAction,
 *		DWORD dwIndex,
 *		DWORD dwValue
 *	)
 *	Parameters
 *		hIMC
 *			Input context handle.
 *		dwAction
 *			dwAction p[^ɃAvP[Vwł context
 *			item ͎̒ʂłB
 *	--------------------------------------------------------------------
 *	NI_OPENCANDIDATE
 *		AvP[V IME Ɍ⃊XgJB IME ⃊
 *		XgJ΁AIME  WM_IME_NOTIFY (Tu֐ IMN_OPENCANDIDATE)
 *		bZ[W𑗐MB
 *		dwIndex		dwIndex ͊Jꂽ⃊Xg indexB
 *		dwValue		gȂB
 *	NI_CLOSECANDIDATE
 *		AvP[V IME Ɍ⃊XgB IME 
 *		XgAIME  WM_IME_NOTIFY (Tu֐ 
 *		IMN_CLOSE_CANDIDATE)bZ[W𑗐MB
 *		dwIndex		⃊Xg index
 *		dwValue		gȂB
 *	NI_SELECTCANDIDATESTR
 *		AvP[V͌1IB
 *		dwIndex		IĂ⃊Xg indexB
 *		dwValue		IĂ⃊Xǧ╶ indexB
 *	NI_CHANGECANDIDATELIST
 *		AvP[V͌ݑIĂύXB
 *		dwIndex		IĂ⃊Xg indexB
 *		dwValue		gȂB
 *	NI_SETCANDIDATE_PAGESTART
 *		AvP[V͌⃊Xg index ͂܂Ăy[W
 *		ύXB
 *		dwIndex		ύX⃊Xg indexB
 *		dwValue		Vy[WJn indexB
 *	NI_SETCANDIDATE_PAGESIZE
 *		AvP[V͌⃊Xg̃y[WTCYύXB
 *		dwIndex		ύX⃊Xg indexB
 *		dwValue		Vy[WTCYB
 *	NI_CONTEXTUPDATED
 *		AvP[V̓VXe Input Context XVB
 *		dwIndex		dwValue ̒l IMC_SETCONVERSIONMODE Ȃ dwIndex 
 *					O conversion mode łB
 *					dwValue ̒l IMC_SETSENTENCEMODE Ȃ dwIndex 
 *					O sentence mode łB
 *					̑ dwValue ɂĂ dwIndex ͎gȂB
 *		dwValue		WM_IME_CONTROL bZ[WɂĎg鎟̒l1:
 *					IMC_SETCANDIDATEPOS
 *					IMC_SETCOMPOSITIONFONT
 *					IMC_SETCOMPOSITIONWINDOW
 *					IMC_SETCONVERSIONMODE
 *					IMC_SETSENTENCEMODE
 *					IMC_SETOPENSTATUS
 *	NI_COMPOSITIONSTR
 *		AvP[V composition string ύXB̓
 *		composition string  input context ɑ݂鎞̂݉eB
 *		dwIndex		dwIndex ɂ͎̂悤Ȓl^B
 *					CPS_COMPLETE
 *						composition string  result string ł
 *						肷B
 *					CPS_CONVERT
 *						composition string ϊB
 *					CPS_REVERT
 *						composition string  revert B݂
 *						composition string LZAϊ
 *						 composition string ƂĐݒ肳B
 *					CPS_CANCEL 
 *						composition string NAāAcomposition
 *						string ԂɂB
 *		dwValue		gȂB
 *	--------------------------------------------------------------------
 *		dwIndex
 *			uAction ɈˑB
 *		dwValue
 *			uAction ɈˑB
 *	Return Values
 *		 TRUEBłȂ FALSEB
 *	See Also
 *		ImmNotifyIME
 ***********************************************************************/
BOOL	WINAPI
NotifyIME (
	HIMC		hIMC,
	DWORD		dwAction,
	DWORD		dwIndex,
	DWORD		dwValue)
{
	static BOOL	(*rpNotifyFunc [])(HIMC, DWORD, DWORD, DWORD) = {
		NULL,										NULL,						
		NULL,										tSkkIme_bOnNotifyContextUpdated,		
		NULL,										NULL,						
		NULL,										NULL,						
		NULL,										NULL,						
		NULL,										NULL,						
		NULL,										NULL,							
		NULL,										NULL,							
		tSkkIme_bOnNotifyOpenCandidate,				tSkkIme_bOnNotifyCloseCandidate,	
		tSkkIme_bOnNotifySelectCandidateStr,		tSkkIme_bOnNotifyChangeCandidateList,
		tSkkIme_bOnNotifyFinalizeConversionResult,	tSkkIme_bOnNotifyCompositionStr,
		tSkkIme_bOnNotifySetCandidatePageStart,		tSkkIme_bOnNotifySetCandidatePageSize,
		tSkkIme_bOnNotifyImeMenuSelected,
	} ;

	DEBUGPRINTFEX (100, (TEXT ("NotifyIME (hIMC: %lx, dwAction: %lx, dwIndex: %lx, dwValue: %lx)\n"), hIMC, dwAction, dwIndex, dwValue)) ;

	if (/*dwAction < 0 ||*/ dwAction > NI_IMEMENUSELECTED || !rpNotifyFunc [dwAction])
		return	FALSE ;

	return	(rpNotifyFunc [dwAction])(hIMC, dwAction, dwIndex, dwValue) ;
}

BOOL
tSkkIme_bOnNotifyContextUpdated (
	HIMC		hIMC,
	DWORD		dwAction,
	DWORD		dwIndex,
	DWORD		dwValue)
{
	TRANSMSG		GnMsg ;
	BOOL			fRet ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifyContextUpdated (hIMC: %lx, dwAction: %lx, dwIndex: %lx, dwValue: %lx)\n"), hIMC, dwAction, dwIndex, dwValue)) ;

	/*	FAKEIME ŎĂ݂ȂƑʖڂB>> FF11
	 *	NotifyIME  IMC_SETOPENSTATUS ꂽAFF11  Status ̕ω𗝉
	 *	Ȃ悤ɌB̗R skkime_IsAwaysOpenKanMode ̒ɂ̂Ƃ
	 *	CɂȂB(IMC_SETCONVERSIONMODE ƂǂׂH)
	 */
	fRet	= FALSE ;
	switch (dwValue){
	case IMC_SETOPENSTATUS:
		if (! ImmGetOpenStatus (hIMC)) {
			TSkkIme_vCloseText (hIMC) ;
			fRet	= TRUE ;
		}
		/*	鎞łJł͓ȁB
		 */
		if (ImeConfig_bKanaModeWhenOpenp ()) {
			LPINPUTCONTEXT	lpIMC ;
			LPMYCOMPSTR		lpMyCompStr ;
			
			lpIMC	= ImmLockIMC (hIMC) ;
			if (lpIMC != NULL) {
				lpMyCompStr		= (LPMYCOMPSTR)ImmLockIMCC (lpIMC->hCompStr) ;
				if (lpMyCompStr != NULL){
					ImeDoc_vClear (&lpMyCompStr->_Doc) ;
					ImeDoc_bSetConversionMode (&lpMyCompStr->_Doc, IMECMODE_HIRAGANA) ; 
					ImmUnlockIMCC (lpIMC->hCompStr) ;
				}
				if (lpIMC->fdwConversion != (IME_CMODE_JAPANESE | IME_CMODE_FULLSHAPE)) 
					lpIMC->fdwConversion	= IME_CMODE_JAPANESE | IME_CMODE_FULLSHAPE ;
				fRet	= TRUE ;
			}
			ImmUnlockIMC (hIMC) ;
		}
		TSkkIme_vUpdateIndicIcon (hIMC) ;
#if !defined (NO_TSF)
		bTSF_UpdateLanguageBar (hIMC) ;
#endif
		break ;

	case	IMC_SETCONVERSIONMODE:
		if (TSkkIme_bUpdateConversionMode (hIMC)) {
			TSkkIme_vUpdateIndicIcon (hIMC) ;
#if !defined (NO_TSF)
			bTSF_UpdateLanguageBar (hIMC) ;
#endif
		}
		fRet	= TRUE ;
		break ;

	case	IMC_SETCOMPOSITIONFONT:
		break ;

	case	IMC_SETSENTENCEMODE:
		break ;

	case	IMC_SETCANDIDATEPOS:
#if defined (DBG) || defined (DEBUG)
		{
			LPINPUTCONTEXT	lpIMC ;
		
			lpIMC	= ImmLockIMC (hIMC) ;
			if (lpIMC != NULL) {
				DEBUGPRINTFEX (106, (TEXT ("IMC_SETCANDIDATEPOS: ChangeStyle4(Wnd:%x, Index:%d)\n"),
						(DWORD) lpIMC->hWnd, lpIMC->cfCandForm [0].dwIndex)) ;
				ImmUnlockIMC (hIMC) ;
			}
		}
#endif
		break ;

	case	IMC_SETCOMPOSITIONWINDOW:
		break ;
	default:
		DEBUGPRINTF ((TEXT ("Unknown --- context updated\n"))) ;
		break;
	}
	return	fRet ;
}

BOOL
tSkkIme_bOnNotifyCompositionStr (
	HIMC		hIMC,
	DWORD		dwAction,
	DWORD		dwIndex,
	DWORD		dwValue)
{
	LPINPUTCONTEXT			lpIMC ;
	BOOL					fRet ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifyCompositionStr (hIMC: 0x%lx, dwAction: 0x%lx, dwIndex: 0x%lx, dwValue: 0x%lx)\n"),	hIMC, dwAction, dwIndex, dwValue)) ;

	fRet	= FALSE ;
	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return FALSE ;

	switch (dwIndex){
	case CPS_COMPLETE:
	case CPS_CANCEL:
		fRet	= (dwIndex == CPS_COMPLETE)? TSkkIme_bCompleteString (hIMC, lpIMC) : TRUE ;
		TSkkIme_vFlushText (hIMC) ;
		break ;
	case CPS_CONVERT:
		fRet	= TSkkIme_bConvertString (hIMC, lpIMC) ;
		break ;
	case CPS_REVERT:
		fRet	= TSkkIme_bRevertString (hIMC, lpIMC) ;
		break ;
	default:
		fRet	= FALSE ;
		break ;
	}
	ImmUnlockIMC (hIMC) ;
	return	fRet ;
}

/*
 *	NI_OPENCANDIDATE
 *		AvP[V IME Ɍ⃊XgJB IME ⃊
 *		XgJ΁AIME  WM_IME_NOTIFY (Tu֐ IMN_OPENCANDIDATE)
 *		bZ[W𑗐MB
 *		dwIndex		dwIndex ͊Jꂽ⃊Xg indexB
 *		dwValue		gȂB
 */
BOOL
tSkkIme_bOnNotifyOpenCandidate (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	LPINPUTCONTEXT	lpIMC ;
	BOOL			fRetval ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifyOpenCandidate (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;
	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return FALSE ;
	fRetval	= TSkkIme_bOpenCandidate (hIMC, lpIMC) ;
	ImmUnlockIMC (hIMC) ;
	return	fRetval ;
}

BOOL
tSkkIme_bOnNotifyCloseCandidate (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	LPINPUTCONTEXT	lpIMC ;
	LPMYCOMPSTR		lpMyCompStr ;
	BOOL			fRetval	= FALSE ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifyCloseCandidate (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;

	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return	FALSE ;

	if (TSkkIme_bHasCandidateListp (lpIMC))
		fRetval	= TSkkIme_bRevertString (hIMC, lpIMC) ;
	ImmUnlockIMC (hIMC) ;
	return	fRetval ;
}

BOOL
tSkkIme_bOnNotifySelectCandidateStr (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	LPINPUTCONTEXT	lpIMC ;
	BOOL			fRetval ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifySelectCandidateStr (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;

	fRetval	= FALSE ;
	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return	FALSE ;

	if (TSkkIme_bHasCandidateListp (lpIMC))
		fRetval	= TSkkIme_bSelectCandidateStr (hIMC, lpIMC, (int)dwValue) ;
	ImmUnlockIMC (hIMC) ;
	return	fRetval ;
}

/*
 *	NI_CHANGECANDIDATELIST
 *		AvP[V͌ݑIĂύXB
 *		dwIndex		IĂ⃊Xg indexB
 *		dwValue		gȂB
 */
BOOL
tSkkIme_bOnNotifyChangeCandidateList (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	LPINPUTCONTEXT		lpIMC ;
	BOOL				fRet ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifyChangeCandidateList (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;

	fRet	= FALSE ;
	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return	FALSE ;
	if (dwIndex == 1 && TSkkIme_bHasCandidateListp (lpIMC))
		fRet	= TRUE ;
	ImmUnlockIMC (hIMC) ;
	return	fRet ;
}

BOOL
tSkkIme_bOnNotifySetCandidatePageSize (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifySetCandidatePageSize (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;

	/*	\Ă Candidate ̃TCYύXƂZ͂ȂB*/
	return	FALSE ;
}

BOOL
tSkkIme_bOnNotifySetCandidatePageStart (
	HIMC		hIMC,
	DWORD		dwAction,
	DWORD		dwIndex,
	DWORD		dwValue)
{
	LPINPUTCONTEXT		lpIMC ;
	LPCANDIDATEINFO		lpCandInfo ;
	LPCANDIDATELIST		lpCandList ;
	BOOL				fRet ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkIme_bOnNotifySetCandidatePageStart (Index:%d, Value:%d)\n"),
						(int)dwIndex, (int)dwValue)) ;

	fRet	= FALSE ;
	lpIMC	= ImmLockIMC (hIMC) ;
	if (!lpIMC)
		return	FALSE ;

	if (dwIndex == 1 && TSkkIme_bHasCandidateListp (lpIMC)) {
		fRet	= TSkkIme_bSetCandidatePageStart (hIMC, lpIMC, (int)dwValue) ;
	}
	ImmUnlockIMC (hIMC) ;
	return	fRet ;
}

BOOL
tSkkIme_bOnNotifyFinalizeConversionResult (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	return	FALSE ;
}

BOOL
tSkkIme_bOnNotifyImeMenuSelected (
	HIMC			hIMC,
	DWORD			dwAction,
	DWORD			dwIndex,
	DWORD			dwValue)
{
	TRANSMSG				GnMsg ;
	LPINPUTCONTEXT	lpIMC ;
	BOOL			fOpen ;

	switch (dwIndex){
	case	IDIM_SHOW_TOOLBAR:
		lpIMC	= ImmLockIMC (hIMC) ;
		if (!lpIMC)
			return	FALSE ;
		SetRegDwordValue (TEXT ("\\Window"), TEXT (REGKEY_HIDETOOLBAR), 0) ;
		GnMsg.message	= WM_IME_NOTIFY ;
		GnMsg.wParam	= IMN_PRIVATE ;
		GnMsg.lParam	= IMN_PRIVATE_SHOWSTATUSWINDOW ;
		GenerateMessage (hIMC, lpIMC, g_lpCurTransKey, (LPTRANSMSG)&GnMsg) ;
		ImmUnlockIMC (hIMC) ;
		TSkkIme_vUpdateIndicIcon (hIMC) ;
		break ;
	case	IDIM_PROPERTY:
		ImeConfigure (GetKeyboardLayout(0), 0, IME_CONFIG_GENERAL, 0) ;
		break ;
	case	IDIM_CANCEL:
		TSkkIme_vUpdateIndicIcon (hIMC) ;
		break ;
	default:
		if (IDM_CMODE_TO_ASCII <= dwIndex && dwIndex <= IDM_CMODE_TO_DIRECTINPUT){
			ChangeConversionModeWithIDM (hIMC, (int) dwIndex) ;
			break ;
		}
		return	FALSE ;
	}
	return	TRUE ;
}

