#pragma once

#include "ImeDoc.h"
#include "TMSG.h"
#include "keymap.h"
#include "varbuffer.h"

#define	MAX_MESSAGES		(16)
#define	MAXIMEBUFFER		(32)
#define	MAX_RETPC			(32)
#define	MSGBUFSIZE			(256)
#define	NSIZE_IMEDOC_STACK	(16384)
#define	NSIZE_REGSTACK		(64)

struct CImeBuffer ;

/*================================================================
 *	ImeDocument Machine ̓WX^Ɋւ`B
 */
enum {
	LMREGTYPE_BOOL,
	LMREGTYPE_NIL,
	LMREGTYPE_INTEGER,
	LMREGTYPE_POINTER,
	LMREGTYPE_CONST_POINTER,
	LMREGTYPE_STRING,
	LMREGTYPE_CONST_STRING,
	LMREGTYPE_STRINGPAIR,
	LMREGTYPE_CONST_STRINGPAIR,
	LMREGTYPE_MESSAGE,
} ;

struct LMREG {
	int			m_nType ;
	union {
		BOOL		m_bool ;
		int			m_integer ;
		void*		m_pointer ;
		const void*	m_const_pointer ;
		struct {
			LPWSTR	m_pointer ;
			int		m_length ;
		}			m_string ;
		struct {
			LPCWSTR	m_pointer ;
			int		m_length ;
		}			m_cstring ;
		struct {
			LPWSTR	m_left ;
			int		m_nleft ;
			LPWSTR	m_right ;
			int		m_nright ;
		}			m_stringpair ;
		struct {
			LPCWSTR	m_left ;
			int		m_nleft ;
			LPCWSTR	m_right ;
			int		m_nright ;
		}			m_cstringpair ;
		struct TMSG	m_msg ;
	}	m_value ;
} ;

struct CImeDocContext {
	PLMFUNC				m_pPC  ;
	PLMFUNC				m_rpRetPC [MAX_RETPC] ;
	int					m_nRetPC ;
	LPBYTE				m_pbStackArea ;
	int					m_nStackAreaSize ;
	int					m_rnStackPos [MAX_RETPC] ;
	int					m_nStackHead ;
	struct LMREG*		m_pRegStack ;
	int					m_nRegStackHead ;
	struct LMREG		m_rREGS [MAX_REGS] ;
	int					m_iThisCommand ;
	int					m_iLastCommand ;
	struct TMSG			m_LastEvent ;
	int					m_iLastCommandChar ;
	struct CImeBuffer*	m_rpBufferState [MAXIMEBUFFER] ;
	struct CImeBuffer*	m_rpBuffer [MAXIMEBUFFER] ;
	int					m_nBuffer ;
	struct CImeBuffer*	m_pCurBuffer ;
	PLMFUNC				m_pPreCommandHook ;
	PLMFUNC				m_pPostCommandHook ;
} ;

/*================================================================
 *	ImeDoc Ɋւ`B
 */
struct CImeDoc {
	/*		lisp machine
	 *
	 *	{IɈ͗^ȂĉŁADocument Class DĉB
	 */
	PLMFUNC			m_pPC  ;		/* s֐B*/
	PLMFUNC			m_rpRetPC [MAX_RETPC] ;	/* subroutine call ̏ꍇ return */
	int				m_nRetPC ;

	/*	call  m_nStackHead ̒l m_rnStackPos [m_nRetPC] ɐς܂B
	 *	LMR_RETURN tāAm_pPC Ɠ m_nStackHead 
	 *	B
	 *	alignment ɒӁB
	 */
	LPBYTE			m_pbStackArea ;
	int				m_nStackAreaSize ;
	int				m_rnStackPos [MAX_RETPC] ;
	int				m_nStackHead ;

	struct LMREG*	m_pRegStack ;
	int				m_nRegStackHead ;

	/*	m_pPC Jڂ鎞̈nɗpB call ŔjĂ\
	 *	̂ŒӁBdvȂ̂ stack ɕۑKvB
	 *
	 *	[AArg nɂ 8- 𗘗pƌ߂邩ȁcB
	 */
	struct LMREG	m_rREGS [MAX_REGS] ;

	/*	return buffer
	 *	LMREGARG_RETVAL H̉BLMREGARG_RETVAL Ɠx̊Ԓxێ
	 *	Ȃ LM_bXXX zĂ̎󂯓n̂߂ɂg̈B
	 *	Areturn Ė߂͑ my heap  my stack ɃRs[ăf[^
	 *	ی삵ȂƂȂB
	 *	return buffer  document class 1ĂB
	 */
	WCHAR			m_bufRETURN [MSGBUFSIZE] ;

	/*		signals
	BOOL			m_bSigAbort ;
	BOOL			m_bSigQuit ;
	BOOL			m_bSigError ;
	BOOL			m_bSigAbortReEdit ;
	BOOL			m_bSigExitReEdit ;
	 */
	int				m_nSignal ;

	/*		events, mesages, commands, and so on
	 */
	struct TMSG		m_rMessages [MAX_MESSAGES] ;
	int				m_nUnreadMessages ;

	int				m_iThisCommand ;
	int				m_iLastCommand ;
	struct TMSG		m_LastEvent ;
	int				m_iLastCommandChar ;

	/*		buffers
	 */
	struct CImeBuffer*	m_rpBuffer [MAXIMEBUFFER] ;
	int					m_nBuffer ;
	struct CImeBuffer*	m_rpUnusedBuffer [MAXIMEBUFFER] ;
	int					m_nUnusedBuffer ;
	struct CImeBuffer*	m_pCurBuffer ;

	/*		subwindow messages
	 */
	WCHAR				m_bufMessage [MSGBUFSIZE] ;
	int					m_nbufMessage ;

	/*		hooks
	 */
	PLMFUNC				m_pPreCommandHook ;
	PLMFUNC				m_pPostCommandHook ;

	/*		XV
	 */
	DWORD				m_dwUpdateFlag ;

	/*		FilterEvent ĂяoꂽAǂ Filter 邱Ƃ̂Ȃ
	 *		Event ~ςB
	 *		WM_NULL  m_nMessage ɐݒ肳Ăꍇɂ́AFilter ꂽ
	 *		ӖĂB
	 *		FilterEvent Ăяo WM_NULL ŏB
	 */
	struct TMSG			m_UnprocessEvent ;

	/*	CANDINFO ̌\p Minibuffer bZ[W(orċA)pB
	 *	(for IME, lpIMC->hCandInfo)
	 */
	TVarbuffer			m_vbufCandInfo ;
	TVarbuffer			m_vbufMessage ;
} ;


/*	internal public functions
 */
#if defined (__cplusplus)
extern "C" {
#endif


#if defined (__cplusplus)
}
#endif

