/* # SKKIME1.0 (Simple Kana-Kanji Input Method Editor for Windows2000)
 * regword.c
 * This file is part of skkime1.0.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "skki1_5.h"
#include "ImeConfig.h"
#include "TSearchSession.h"
#include "TJisyoUpdateSession.h"

/*
 *	Definitions
 */
#define	SKKWORD_OKURIARI	(IME_REGWORD_STYLE_USER_FIRST+0)
#define SKKWORD_OKURINASI	(IME_REGWORD_STYLE_USER_FIRST+1)

/*************************************************************************
 *	ImeRegisterWord
 *	ImeRegisterWord ֐݂͌IME̎ɕo^܂B
 *	BOOL WINAPI
 *		ImeRegisterWord(
 *		LPCTSTR lpszReading,
 *		DWORD dwStyle,
 *		LPCTSTR lpszString
 *	)
 *	(p[^)
 *		lpszReading
 *			o^镶̓ǂ݁B
 *		dwStyle
 *			o^镶̃X^CB̂悤ȒlpӂĂ܂B
 *	
 *			IME_REGWORD_STYLE_EUDC
 *				 EUDC ͈̔͂ɂB
 *			IME_REGWORD_STYLE_USER_FIRST  IME_REGWORD_STYLE_USER_LAST	
 *				IME_REGWORD_STYLE_USER_FIRST  
 *				IME_REGWORD_STYLE_USER_LAST ͈̔͂ IME ISV  private
 *				style ɎgBIME ISV ͎RɓƎ̃X^C`
 *				悢B
 *				Ⴆ΁A
 *					#define MSIME_NOUN	(IME_REGWORD_STYLE_USER_FIRST)
 *					#define	MSIME_VERB	(IME_REGWORD_STYLE_USER_FIRST+1)
 *		lpszString
 *			o^镶B
 *	(Ԃl)
 *		Ȃ΁ATRUE BȂ FALSE ԂB
 *************************************************************************/
BOOL	WINAPI
ImeRegisterWord (
	register LPCTSTR		lpRead,
	register DWORD			dw,
	register LPCTSTR		lpStr)
{
#if defined (MIXED_UNICODE_ANSI)
	MYCHAR			szKey  [MAXCOMPSIZE + 1] ;
	MYCHAR			szWord [MAXCOMPSIZE + 1] ;
	register int	n ;
#endif
	if (lpRead == NULL || lpStr == NULL)
		return	FALSE ;

	/*	艼^iȂcBǂ̂悤Ɍ肷ׂH
	 */
	if ((dw == SKKWORD_OKURIARI) || (dw == SKKWORD_OKURINASI)){
#if defined (MIXED_UNICODE_ANSI)
		n	= MultiByteToWideChar (CP_OEMCP, MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								   lpRead, NULL, szKey, MAXCOMPSIZE) ;
		if (n == 0 || n >= MAXCOMPSIZE)
			return	FALSE ;
		szKey [n]			= MYTEXT ('\0') ;
		n	= MultiByteToWideChar (CP_OEMCP, MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								   lpStr NULL, szWord, MAXCOMPSIZE) ;
		if (n == 0 || n >= MAXCOMPSIZE)
			return	FALSE ;
		szWord [n]			= MYTEXT ('\0') ;
		return	TRecordSession_bUpdate	(szKey, Mylstrlen (szKey), NULL, 0, szWord, Mylstren (szWord), (dw == SKKWORD_OKURIARI)) ;
#else
		return	TRecordSession_bUpdate	(lpRead, Mylstrlen (lpRead), NULL, 0, lpStr, Mylstrlen (lpStr), (dw == SKKWORD_OKURIARI)) ;
#endif
	}
	return	FALSE ;
}

/*************************************************************************
 *	ImeUnregisterWord
 *	ImeUnregisterWord ݂͌IME̎o^Ă镶폜
 *	B
 *	BOOL WINAPI
 *		ImeUnregisterWord(
 *		LPCTSTR lpszReading,
 *		DWORD dwStyle,
 *		LPCTSTR lpszString
 *	)
 *	(p[^)
 *		lpszReading
 *			o^Ă镶̓ǂ݁B
 *		dwStyle
 *			o^Ă镶̃X^CBdwStyle ̒gɂĂ
 *			ImeRegisterWord ̐QƂ̂ƁB
 *		lpszString
 *			폜镶B
 *	(Ԃl)
 *		Ȃ΁ATRUE BȂ FALSE ԂB
 *************************************************************************/
BOOL	WINAPI
ImeUnregisterWord (
	register LPCTSTR		lpRead,
	register DWORD			dw,
	register LPCTSTR		lpStr)
{
#if defined (MIXED_UNICODE_ANSI)
	MYCHAR			szKey  [MAXCOMPSIZE + 1] ;
	MYCHAR			szWord [MAXCOMPSIZE + 1] ;
	register int	n ;
#endif
	if (lpRead == NULL || lpStr == NULL)
		return	FALSE ;

	if ((dw == SKKWORD_OKURIARI) || (dw== SKKWORD_OKURINASI)){
#if defined (MIXED_UNICODE_ANSI)
		n	= MultiByteToWideChar (CP_OEMCP, MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								   lpRead, NULL, szKey, MAXCOMPSIZE) ;
		if (n == 0 || n >= MAXCOMPSIZE)
			return	FALSE ;
		szKey [n]			= MYTEXT ('\0') ;
		n	= MultiByteToWideChar (CP_OEMCP, MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
								   lpStr NULL, szWord, MAXCOMPSIZE) ;
		if (n == 0 || n >= MAXCOMPSIZE)
			return	FALSE ;
		szWord [n]			= MYTEXT ('\0') ;
		return	TPurgeSession_bUpdate (szKey, Mylstrlen (szKey), NULL, 0, szWord, Mylstrlen (szWord), (dw == SKKWORD_OKURIARI)) ;
#else
		return	TPurgeSession_bUpdate (lpRead, lstrlenW (lpRead), NULL, 0, lpStr, lstrlenW (lpStr), (dw == SKKWORD_OKURIARI)) ;
#endif
	}
	return	FALSE ;
}

/*************************************************************************
 *	ImeGetRegisterWordStyle
 *	ImeGetRegisterWordStyle ݂͌IMEŗp\ȃX^C𓾂܂B
 *	UINT WINAPI
 *		ImeGetRegisterWordStyle(
 *		UINT nItem,
 *		LPSTYLEBUF lpStyleBuf
 *	)
 *	(p[^)
 *		nItem
 *			obt@ɕۑ\ȃX^C̍ő吔B
 *		lpStyleBuf
 *			ׂobt@B
 *	(Ԃl)
 *		obt@ɃRs[ꂽX^C̐ԂlłBAnItems 
 *		Ȃ΁AIMEłׂẲ\ȃX^C󂯎̂ɕKvȔz
 *		vfɂȂ܂B
 *************************************************************************/
UINT	WINAPI
ImeGetRegisterWordStyle (UINT u, LPSTYLEBUF lp)
{
	UINT	uRet	= 0 ;
	if (u > 0 && lp){
		lp->dwStyle	= SKKWORD_OKURIARI ;
		lstrcpy (lp->szDescription, TEXT ("OKURI-ARI")) ;
		if (u > 1){
			lp	++ ;
			lp->dwStyle	= SKKWORD_OKURINASI ; 
			lstrcpy (lp->szDescription, TEXT ("OKURI-NASI")) ;
		}
	} else {
		uRet = 2 ;
	}
	return	uRet ;
}

/*************************************************************************
 *	ImeEnumRegisterWord
 *	ImeEnumRegisterWord ͓肳ꂽǂ݁AX^CAo^ꂽf[^
 *	łēo^Ă镶̏񋓂܂B
 *	UINT WINAPI
 *		ImeEnumRegisterWord(
 *		hKL,
 *		REGISTERWORDENUMPROC lpfnEnumProc,
 *		LPCTSTR lpszReading,
 *		DWORD dwStyle,
 *		LPCTSTR lpszString,
 *		LPVOID lpData
 *	)
 *	(p[^)
 *		hKL
 *			Input language handle.
 *		lpfnEnumProc
 *			callback ֐̃AhXB
 *		lpszReading
 *			񋓂ǂ݂肵܂BNULLȂ΁AdwStyle y lpszString
 *			p[^ɈvSẲ\ȓǂ݂񋓂܂B
 *		dwStyle
 *			񋓂X^C肵܂BNULLȂ΁AlpszReading y
 *			lpszString p[^ɈvSẲ\ȃX^C񋓂
 *			B
 *		lpszString
 *			񋓂镶肵܂BNULLȂ΁AImeEnumRegisterWord
 *			 lpszReading y dwStyle p[^vSĂ̕
 *			񋓂܂B
 *		lpData
 *			AvP[Vpӂf[^̃AhX
 *	(Ԃl)
 *		Ȃ΁Acallback function ɍŌɕԂꂽlԂlɂȂ܂B
 *		AvP[VɂĂ̈Ӗ͌߂܂B
 *	(Rg)
 *		SẴp[^ NULL AIME ̑SĂ̓o^Ă
 *		񋓂܂Bij
 *		̓p[^̂QNULLꍇɂ́AcRڂ̃p[
 *		^ɓKo^Ă镶Sė񋓂܂B
 *	(lIȃRg)
 *		̍\Ȃ肤܂߂ĂȂƁAȂƂꂽd
 *		ĂĂȂȂ܂B͖ܘ_t\łAƂ
 *		͍̂Œ݂łB
 *		SKKƂ͍̑ňł́H
 *************************************************************************/
UINT	WINAPI
ImeEnumRegisterWord (
	REGISTERWORDENUMPROC	lpfn,
	LPCTSTR					lpRead,
	DWORD					dw,
	LPCTSTR					lpStr,
	LPVOID					lpData)
{
	struct CTSearchSession*	pHenkanSession ;
	UINT				uRet	= 0 ;
	LPCWSTR				wstr ;
#if defined (MIXED_UNICODE_ANSI)
	MYCHAR				szRead	[MAXCOMPSIZE + 1] ;
	MYCHAR				szWord	[MAXCOMPSIZE + 1] ;
	TCHAR				szTWord	[MAXCOMPSIZE + 1] ;
	int					nRead, nStr, nLength ;
#endif

	if (!lpfn || !lpRead)
		return	0 ;

#if defined (MIXED_UNICODE_ANSI)
	nRead	= shiftJisToMystr (szRead, MAXCOMPSIZE, lpRead, lstrlen (lpRead)) ;
	szRead [nRead]	= MYTEXT ('\0') ;

	if (lpStr){
		nStr	= shiftJisToMystr (szWord, MAXCOMPSIZE, lpStr, lstrlen (lpStr)) ;
	} else {
		nStr	= 0 ;
	}
	szWord [nStr]	= MYTEXT ('\0') ;
#endif

	if (dw == 0 || dw != SKKWORD_OKURIARI) {
#if defined (MIXED_UNICODE_ANSI)
		pHenkanSession	= THenkanSession_pCreate (szRead, nRead, SEARCH_OKURI_NASHI, ImeConfig_bSkkNumericConversionp (), ImeConfig_bSkkNumConvertFloatp ()) ;
#else
		pHenkanSession	= THenkanSession_pCreate (lpRead, lstrlenW (lpRead), SEARCH_OKURI_NASHI, ImeConfig_bSkkNumericConversionp (), ImeConfig_bSkkNumConvertFloatp ()) ;
#endif
		if (pHenkanSession != NULL) {
			do {
				wstr	= TSearchSession_pGetCandidate (pHenkanSession) ;
				if (wstr == NULL)
					break ;
#if defined (MIXED_UNICODE_ANSI)
				if (!lpStr || !Mylstrcmp (szWord, wstr)){
					/* Unicode  ShiftJIS ɕϊĂłȂ Callback ĂяoȂB*/
					nLength	= MystrToShiftJis (szTWord, MAXCOMPSIZE, wstr, lstrlenW (str)) ;
					szTWord [nLength]	= TEXT ('\0') ;
					/* callback ֐ĂяoB*/
					uRet	= (*lpfn)(lpRead, dw, szTWord, lpData) ;
					if (!uRet)
						break ;
				}
#else
				if (!lpStr || !lstrcmpW (lpStr, wstr)){
					/* callback ֐ĂяoB*/
					uRet	= (*lpfn)(lpRead, dw, wstr, lpData) ;
					if (!uRet)
						break ;
				}
#endif
			}	while (TSearchSession_bNextCandidate (pHenkanSession)) ;

			TSearchSession_vDestroy (pHenkanSession) ;
		}
		if (! uRet)
			return	uRet ;
	}
	if (dw == 0 || dw == SKKWORD_OKURIARI) {
#if defined (MIXED_UNICODE_ANSI)
		pHenkanSession	= TOkuriHenkanSession_pCreate (szRead, nRead, NULL, 0, FALSE, TRUE, FALSE) ;
#else
		pHenkanSession	= TOkuriHenkanSession_pCreate (lpRead, lstrlenW (lpRead), NULL, 0, FALSE, TRUE, FALSE) ;
#endif
		if (pHenkanSession != NULL) {
			do {
				wstr	= TSearchSession_pGetCandidate (pHenkanSession) ;
				if (wstr == NULL)
					break ;
#if defined (MIXED_UNICODE_ANSI)
				if (!lpStr || !Mylstrcmp (szWord, wstr)){
					/* Unicode  ShiftJIS ɕϊĂłȂ Callback ĂяoȂB*/
					nLength	= MystrToShiftJis (szTWord, MAXCOMPSIZE, wstr, lstrlenW (str)) ;
					szTWord [nLength]	= TEXT ('\0') ;
					/* callback ֐ĂяoB*/
					uRet	= (*lpfn)(lpRead, dw, szTWord, lpData) ;
					if (!uRet)
						break ;
				}
#else
				if (!lpStr || !lstrcmpW (lpStr, wstr)){
					/* callback ֐ĂяoB*/
					uRet	= (*lpfn)(lpRead, dw, wstr, lpData) ;
					if (!uRet)
						break ;
				}
#endif
			}	while (TSearchSession_bNextCandidate (pHenkanSession)) ;

			TSearchSession_vDestroy (pHenkanSession) ;
		}
	}
	return	uRet ;
}

