#pragma once

struct CTSearchSession ;
struct CTS4Candidate ;
struct CTS4Mapping ;

enum {
	SEARCH_OKURI_NASHI	= 0,
	SEARCH_OKURI_ARI,
	SEARCH_OKURI_STRICT,
	SEARCH_OKURI_STRICT_PRECEDENCE,
	SEARCH_OKURI_AUTO,
} ;

/*========================================================================
 *	prototypes
 */
LPCWSTR		TSearchSession_pGetReferCandidate		(struct CTSearchSession*) ;
LPCWSTR		TSearchSession_pGetCandidate			(struct CTSearchSession*) ;
LPCWSTR		TSearchSession_pGetKeyword				(struct CTSearchSession*, int*) ;
BOOL		TSearchSession_bNextCandidate			(struct CTSearchSession*) ;
BOOL		TSearchSession_bPreviousCandidate		(struct CTSearchSession*) ;
BOOL		TSearchSession_bInsertCandidate			(struct CTSearchSession*, LPCWSTR, int) ;
BOOL		TSearchSession_bInsertCandidateWithS4Mapping	(struct CTSearchSession*, LPCWSTR, int, const struct CTS4Mapping*) ;
BOOL		TSearchSession_bRewind					(struct CTSearchSession*) ;
void		TSearchSession_vDestroy					(struct CTSearchSession*) ;
int			TSearchSession_iGetNumberOfCandidate	(struct CTSearchSession*, BOOL*) ;
BOOL		TSearchSession_bNumericp				(const struct CTSearchSession*) ;
LPCWSTR		TSearchSession_pGetNumericList			(const struct CTSearchSession*) ;

struct CTS4Candidate*	TSearchSession_pGetNumericLink	(struct CTSearchSession*) ;
LPCWSTR		TSearchSession_pGetNumericKeyword	(struct CTSearchSession*, struct CTS4Candidate*, int*) ;
LPCWSTR		TSearchSession_pGetNumericResult	(struct CTSearchSession*, struct CTS4Candidate*, int*) ;
struct CTS4Candidate*	TSearchSession_pGetNextNumericLink	(struct CTSearchSession*, struct CTS4Candidate*) ;

struct CTSearchSession*	TCompletionSession_pCreate	(LPCWSTR, int) ;
struct CTSearchSession*	TOkuriHenkanSession_pCreate	(LPCWSTR, int, LPCWSTR, int, int, BOOL, BOOL) ;
struct CTSearchSession*	THenkanSession_pCreate		(LPCWSTR, int, int, BOOL, BOOL) ;
struct CTSearchSession*	TKakuteiHistoryCompletionSession_pCreate (void) ;

struct CTS4Mapping*		TS4Mapping_pCreate			(LPCWSTR, LPCWSTR, int) ;
BOOL		TS4Mapping_bInsertLast					(struct CTS4Mapping**, struct CTS4Mapping*) ;
void		TS4Mapping_vClearList					(struct CTS4Mapping*) ;


