/* # SKKIME1.0 (Simple Kana-Kanji Input Method Editor for Windows2000)
 * winfile.c
 * This file is part of skkime1.0.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "skki1_5.h"
#include "winfile.h"

BOOL	PASCAL
winfileinit (
	register LPWINFILE		lpWinFile)
{
	lpWinFile->hFile 				= INVALID_HANDLE_VALUE ;
	lpWinFile->hread_pointer		= -1 ;
	lpWinFile->hread_pointer_max	= 0 ;
	lpWinFile->file_head			= 0 ;
	return	TRUE ;
}

BOOL	PASCAL
winfopen (
	register LPWINFILE		lpWinFile,
	register LPCTSTR		lpfile,
	register DWORD			dwAccess,
	register DWORD			dwCreateFlag)
{
	register HANDLE		hFile ;

	if (!lpWinFile || !lpfile)
		return	FALSE ;

	winfileinit (lpWinFile) ;
	/* t@CJƎ݂B*/
	hFile		= CreateFile (lpfile, dwAccess, FILE_SHARE_READ, NULL, dwCreateFlag, FILE_ATTRIBUTE_NORMAL, NULL) ;
	if (hFile == INVALID_HANDLE_VALUE)
		return	FALSE ;
	lpWinFile->hFile				= hFile ;
	lpWinFile->hread_pointer		= -1 ;
	lpWinFile->hread_pointer_max	= 0 ;
	lpWinFile->file_head			= 0 ;
	return	TRUE ;
}

BOOL	PASCAL
winfclose (
	register LPWINFILE		lpWinFile)
{
	if (lpWinFile == NULL)
		return	FALSE ;
	if (lpWinFile->hFile != INVALID_HANDLE_VALUE){
		CloseHandle (lpWinFile->hFile) ;
		lpWinFile->hFile	= INVALID_HANDLE_VALUE ;
	}
	lpWinFile->hread_pointer		= -1 ;
	lpWinFile->hread_pointer_max	= 0 ;
	lpWinFile->file_head			= 0 ;
	return	TRUE ;
}

int		PASCAL
winfgetc (
	register LPWINFILE		lpWinFile)
{
	DWORD	dwNumberOfBytesRead ;
	char	c ;
	BOOL	bResult ;
	if (lpWinFile->hread_pointer < 0 || lpWinFile->hread_pointer >= lpWinFile->hread_pointer_max){
		bResult	= ReadFile (lpWinFile->hFile, lpWinFile->hread_buffer, HREADBUFSIZE, &dwNumberOfBytesRead, NULL) ;
		if (!bResult || dwNumberOfBytesRead == 0){
			lpWinFile->hread_pointer		= -1 ;
			lpWinFile->hread_pointer_max	= 0 ;
			return	EOF ;
		}
		lpWinFile->hread_pointer		= 0 ;
		lpWinFile->hread_pointer_max	= (long)dwNumberOfBytesRead ;
		lpWinFile->file_head	+= lpWinFile->hread_pointer_max ;
	}
	return	(int)lpWinFile->hread_buffer [lpWinFile->hread_pointer ++] & 0x00FF ;
}

char*	PASCAL	winfgets (char* s, int n, LPWINFILE lpWinFile)
{
	int		c ;
	char*	cs ;
	cs	= s;
	while (--n > 0 && (c = winfgetc (lpWinFile)) != EOF)
		if ((*cs ++ = (char)c) == '\n')
			break ;
	*cs	= '\n' ;
	return	(c == EOF && cs == s)? NULL : s ;
}

int	PASCAL	winfread (LPVOID lpBuffer, int iSize, int iCount, LPWINFILE lpWinFile)
{
	long	lTotalRead ;
	long	lRest ;
	BOOL	fRet ;
	DWORD	dwNumberOfBytesRead ;
	lTotalRead	= iSize * iCount ;
	/* ǂݏoڂ̐0ȂA0ԂƂ͕Ă̂ŁB*/
	if (lTotalRead == 0)
		return	0 ;
	/* obt@OĂ邩ǂB*/
	if (lpWinFile->hread_pointer < 0){
		/* ǂݍލڂ̐Ȃ΁AxɑʂɓǂݍŃobt@ÔgB*/
		if (lTotalRead < HREADBUFSIZE){
			fRet	= ReadFile (lpWinFile->hFile, lpWinFile->hread_buffer, HREADBUFSIZE, &dwNumberOfBytesRead, NULL) ;
			if (fRet){
				lpWinFile->hread_pointer_max	= (long)dwNumberOfBytesRead ;
				lpWinFile->file_head	+= lpWinFile->hread_pointer_max ;
				if (dwNumberOfBytesRead < (DWORD)lTotalRead){
					memcpy ((char*)lpBuffer, lpWinFile->hread_buffer, dwNumberOfBytesRead) ;
					lpWinFile->hread_pointer	= (long)dwNumberOfBytesRead ;
				} else {
					memcpy ((char*)lpBuffer, lpWinFile->hread_buffer, lTotalRead) ;
					lpWinFile->hread_pointer	= lTotalRead ;
				}
			}
		} else {
			fRet	= ReadFile (lpWinFile->hFile, (char*)lpBuffer, (DWORD)lTotalRead, &dwNumberOfBytesRead, NULL) ;
			lpWinFile->file_head		+= (long)dwNumberOfBytesRead ;
		}
	} else {
		/* obt@OĂ̂ȂÅmۂꂽڂRs[KvB*/
		lRest	= lpWinFile->hread_pointer_max - lpWinFile->hread_pointer ;
		if (lRest >= lTotalRead){
			memcpy ((char*)lpBuffer, lpWinFile->hread_buffer + lpWinFile->hread_pointer, lTotalRead) ;
			lpWinFile->hread_pointer	+= lTotalRead ;
			dwNumberOfBytesRead			= (DWORD)lTotalRead ;
			fRet	= TRUE ;
		} else {
			memcpy ((char*)lpBuffer, lpWinFile->hread_buffer + lpWinFile->hread_pointer, lRest) ;
			lpWinFile->hread_pointer	= -1 ;
			fRet	= ReadFile (lpWinFile->hFile, (char*)lpBuffer + lRest, (DWORD)(lTotalRead - lRest), &dwNumberOfBytesRead, NULL) ;
			lpWinFile->file_head	+= (long)dwNumberOfBytesRead ;
			dwNumberOfBytesRead		+= (DWORD)lRest ;
		}
	}
	if (!fRet)
		return	0 ;
	return	dwNumberOfBytesRead / (DWORD)iSize ;
}

int	PASCAL	winfputc (char c, LPWINFILE lpWinFile)
{
	DWORD	dwNumberOfBytesWrite ;
	long	lDistanceLow ;
	BOOL	fRetvalue ;
	/* ǂݍ݃obt@łȂꍇɂ́At@Cwbh߂KvB*/
	if (lpWinFile->hread_pointer >= 0){
		lDistanceLow	= SetFilePointer (lpWinFile->hFile, lpWinFile->file_head - lpWinFile->hread_pointer + lpWinFile->hread_pointer_max, NULL, FILE_BEGIN) ;
		lpWinFile->file_head	= lDistanceLow ;
		/* ŃG[oA܂łBt@C̈ʒu邱Ƃ͕s\B*/
		if (lDistanceLow == 0xFFFFFFFF && GetLastError() != NO_ERROR)
			return	EOF ;
		lpWinFile->hread_pointer		= -1 ;
	}
	fRetvalue	= WriteFile (lpWinFile->hFile, &c, 1, &dwNumberOfBytesWrite, NULL) ;
	/* 񂾂Ƃœǂݍ݃obt@̓NAB*/
	lpWinFile->hread_pointer		= -1 ;
	if (!fRetvalue || dwNumberOfBytesWrite != 1)
		return	EOF ;
	lpWinFile->file_head	++ ;
	return	0 ;
}

int		PASCAL	winfwrite (LPCVOID lpBuffer, int iSize, int iCount, LPWINFILE lpWinFile)
{
	DWORD	dwNumberOfBytesWrite ;
	long	lDistanceLow ;
	BOOL	fRetvalue ;
	/* ǂݍ݃obt@łȂꍇɂ́At@Cwbh߂KvB*/
	if (lpWinFile->hread_pointer >= 0){
		lDistanceLow	= SetFilePointer (lpWinFile->hFile, lpWinFile->file_head - lpWinFile->hread_pointer + lpWinFile->hread_pointer_max, NULL, FILE_BEGIN) ;
		lpWinFile->file_head	= lDistanceLow ;
		/* ŃG[oA܂łBt@C̈ʒu邱Ƃ͕s\B*/
		if (lDistanceLow == 0xFFFFFFFF && GetLastError() != NO_ERROR)
			return	EOF ;
		lpWinFile->hread_pointer		= -1 ;
	}
	fRetvalue	= WriteFile (lpWinFile->hFile, lpBuffer, iSize * iCount, &dwNumberOfBytesWrite, NULL) ;
	/* 񂾂Ƃœǂݍ݃obt@̓NAB*/
	lpWinFile->hread_pointer		= -1 ;
	if (!fRetvalue)
		return	0 ;
	lpWinFile->file_head	+= dwNumberOfBytesWrite ;
	return	dwNumberOfBytesWrite ;
}

long	PASCAL	winftell (LPWINFILE lpWinFile)
{
	LONG	lDistanceLow ;
	/* t@Cwbh(sȒl)ĂAt@Cwbh蒼B*/
	if (lpWinFile->file_head < 0)
		lpWinFile->file_head	= SetFilePointer (lpWinFile->hFile, 0, NULL, FILE_BEGIN) ;
	/* ǂݍ݃obt@ʒuŕ␳B*/
	if (lpWinFile->hread_pointer >= 0){
		lDistanceLow	= lpWinFile->file_head - lpWinFile->hread_pointer_max + lpWinFile->hread_pointer ;
	} else {
		lDistanceLow	= lpWinFile->file_head ;
	}
	return	lDistanceLow ;
}

int	PASCAL	winfseek (LPWINFILE lpWinFile, long lDistanceLow, DWORD dwPos)
{
	long	lDistanceHigh ;
	long	lMoveDistance ;

	/* t@CwbhړKvꍇH ܂͊Ƀobt@ɓǂ݂܂Ă͈͓
	 * ł̈ړł邩? */
	if (lpWinFile->hread_pointer >= 0){
		lMoveDistance	= lDistanceLow - (lpWinFile->file_head - lpWinFile->hread_pointer_max) ;
		if (0 <= lMoveDistance && lMoveDistance < lpWinFile->hread_pointer_max){
			lpWinFile->hread_pointer	= lMoveDistance ;
			return	0 ;
		}
	}
	/* t@Cwbhړ邱Ƃɂǂݍ݃obt@̓tbVB*/
	lDistanceHigh	= 0 ;
	lDistanceLow	= SetFilePointer (lpWinFile->hFile, lDistanceLow, &lDistanceHigh, dwPos) ;
	if (lDistanceLow == 0xFFFFFFFF && GetLastError() != NO_ERROR){
		lpWinFile->hread_pointer	= -1 ;
		lpWinFile->file_head		= -1 ;
		return	-1 ;
	}
	lpWinFile->hread_pointer	= -1 ;
	lpWinFile->file_head		= lDistanceLow ;
	return	0 ;
}

int	PASCAL	winrewind (LPWINFILE lpWinFile)
{
	LONG	lDistanceHigh ;
	LONG	lDistanceLow ;
	long	lMoveDistance ;

	/* t@CwbhړKvꍇH ܂͊Ƀobt@ɓǂ݂܂Ă͈͓
	 * ł̈ړł邩? */
	if (lpWinFile->hread_pointer >= 0){
		lMoveDistance	= lpWinFile->hread_pointer_max - lpWinFile->file_head ;
		if (0 <= lMoveDistance && lMoveDistance < lpWinFile->hread_pointer_max){
			lpWinFile->hread_pointer	= lMoveDistance ;
			return	0 ;
		}
	}
	/* t@Cwbhړ邱Ƃɂǂݍ݃obt@̓tbVB*/
	lDistanceHigh	= 0 ;
	lDistanceLow	= SetFilePointer (lpWinFile->hFile, 0, (PLONG)&lDistanceHigh, FILE_BEGIN) ;
	if (lDistanceLow == 0xFFFFFFFF && GetLastError() != NO_ERROR){
		lpWinFile->hread_pointer	= -1 ;
		lpWinFile->file_head		= -1 ;
		return	-1 ;
	}
	lpWinFile->file_head		= lDistanceLow ;
	lpWinFile->hread_pointer	= -1 ;
	return	0 ;
}

