/* # SKKIME1.0 (Simple Kana-Kanji Input Method Editor for Windows2000)
 * winfile.h
 * This file is part of skkime1.0.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#if !defined(winfile_h)
#define	winfile_h

/*
 *	Definitions
 */
#ifndef	HREADBUFSIZE
#define	HREADBUFSIZE	(4096)		/* 512 * 64 = 4096 */
#endif
#ifndef	EOF
#define	EOF				(-1)
#endif

/*
 *	Structures
 */
typedef struct	tagWINFILE {
	HANDLE	hFile ;
	char	hread_buffer [HREADBUFSIZE] ;
	long	hread_pointer ;
	long	hread_pointer_max ;
	long	file_head ;
}	WINFILE, NEAR *PWINFILE, FAR *LPWINFILE ;

/*
 *	Prototypes
 */
BOOL	PASCAL	winfileinit (LPWINFILE lpWinFile) ;
BOOL	PASCAL	winfopen (LPWINFILE lpWinFile, LPCTSTR lpfile, DWORD dwAccess, DWORD dwCreateFlag) ;
BOOL	PASCAL	winfclose (LPWINFILE lpWinFile) ;
int		PASCAL	winfgetc (LPWINFILE lpWinFile) ;
char*	PASCAL	winfgets (char* s, int n, LPWINFILE lpWinFile) ;
int		PASCAL	winfread (LPVOID lpBuffer, int iSize, int iCount, LPWINFILE lpWinFile) ;
int		PASCAL	winfputc (char c, LPWINFILE lpWinFile) ;
int		PASCAL	winfwrite (LPCVOID lpBuffer, int iSize, int iCount, LPWINFILE lpWinFile) ;
long	PASCAL	winftell (LPWINFILE lpWinFile) ;
int		PASCAL	winfseek (LPWINFILE lpWinFile, long lDistanceLow, DWORD dwPos) ;
int		PASCAL	winrewind (LPWINFILE lpWinFile) ;

#endif

