#if !defined (NO_TSF)
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
extern "C" {
#include "skki1_5.h"
#include "resource.h"
}
#include "msctf_.h"
#include "tsf.h"

/*
#undef	DEBUGPRINTF
#undef	DEBUGPRINTFEX
#undef	DBG
#define	DBG	1
#define	DEBUGPRINTF(arg)			DebugPrintf##arg
#define	DEBUGPRINTFEX(level,arg)	DebugPrintf##arg
#define	TSF_MUTEX	1
*/

#define	NUM_LANGBAR_ITEM_BUTTON	(2)
#define	NUM_TSF_GETITEMS		(15)
#define	TSF_WAITTIME			(3 * 1000)

#define	REGPATH_CTF_PATH						TEXT("Software\\Microsoft\\CTF")
#define	REGKEY_CTF_DISABLE_THREAD_INPUT_MANAGER	TEXT("Disable Thread Input Manager")

typedef HRESULT (WINAPI *PTF_GETTHREADMGR)(ITfThreadMgr **pptim) ;

/*========================================================================
 *	prototypes
 */
static	ITfThreadMgr*		_QueryThreadMgr					(void) ;
static	ITfThreadMgr*		_GetThreadMgr					(void) ;
static	ITfLangBarItemMgr*	_QueryLangBarItemMgr			(void) ;
static	BOOL				_IsCtfThreadInputManagerEnabled (void) ;
static	void				_DumpLangBarItem				(void) ;
static	BOOL				_showKeyboardIcon				(ITfLangBarItemMgr*, BOOL fShow) ;

/*========================================================================
 *	global variables
 */
static	HMODULE				g_hMSCTF			= NULL ;
static	TfClientId			g_tfClientID ;
static	BOOL				g_bInitTSF			= FALSE ;

/*	LangBar ɓo^ Item  clsid ɂ́A IME Ƃ{^Ɠ CLSID ɐ
 *	肷Kv悤BMS-IME2002 ̋QƂɁB
 *	K CLSID ݒ肵Ă܂ uSort @\Ȃ߂ Icon ̓o^ʒu
 *	ŌɂȂĂ܂BCLSID_NULL ɂƃL[{[hACROɗĂ܂B
 *	ӂ邱ƁB(ǋLFThu Jul 05 14:31:59 2007)
 */
const CLSID	c_clsidSkkImeTextService	= {
	0x77B34286, 0xED57, 0x45E2, { 0x97, 0x66, 0xD8, 0xC5, 0xFE, 0x3D, 0xFB, 0x2C }
} ;

// {4920BE55-E37F-47eb-B868-2C4D6F5FB4B6}
const GUID	c_guidSkkImeProfile = {
	0x4920be55, 0xe37f, 0x47eb, { 0xb8, 0x68, 0x2c, 0x4d, 0x6f, 0x5f, 0xb4, 0xb6 }
} ;

// {5D97B50B-1B86-4577-AAF6-BD76E50B18EC}
const GUID	c_guidItemButtonCMode = {
	0x5d97b50b, 0x1b86, 0x4577, { 0xaa, 0xf6, 0xbd, 0x76, 0xe5, 0xb, 0x18, 0xec }
} ;

// {F0E6F1F4-B3AA-4ef6-96D7-3353F5803730}
const GUID	c_guidItemButtonIME	= {
	0xf0e6f1f4, 0xb3aa, 0x4ef6, { 0x96, 0xd7, 0x33, 0x53, 0xf5, 0x80, 0x37, 0x30 }
} ;

/*	 button Ɍ邪Askimic.dll Ɠ̂ĝ͔Ȃ΂Ȃ
 *	悤BɂĂ̂ƂςscB
 *
const GUID	c_guidItemButtonCMode = {
	0x82fd14c8, 0xa99a, 0x4882, { 0xa6, 0xe5, 0x74, 0x93, 0xca, 0x67, 0x86, 0x6a }
} ;

// {EDA78BBB-65F7-4a1b-9551-309D9FE6200C}
const GUID	c_guidItemButtonIME	= {
	0xeda78bbb, 0x65f7, 0x4a1b, { 0x95, 0x51, 0x30, 0x9d, 0x9f, 0xe6, 0x20, 0xc }
} ;
*/

/*	L[{[h{^ GUIDB炭͂̒lňӂɌ肷锤B
 */
const GUID	c_guidKeyboardItemButton	= {
	0x34745C63, 0xB2F0, 0x4784, { 0x8B, 0x67, 0x5E, 0x12, 0xC8, 0x70, 0x1A, 0x31 }
} ;

/*========================================================================
 *	functions
 */
BOOL	PASCAL
bTSF_InitLanguageBar (void)
{
	ITfInputProcessorProfiles*	pInputProcessorProfiles ;

	DEBUGPRINTF ((TEXT ("Enter::InitLanguageBar\n"))) ;

	/*	Logon ɂ TSF ͌ĂяoȂB*/
	if (g_bSkkImeSecure) 
		return	FALSE ;
	if (g_bInitTSF) 
		return	TRUE ;

	g_hMSCTF		= LoadLibrary (TEXT ("msctf.dll")) ;

	/*	LoadLibrary ̌ʂ͌ȂBsꍇAsƂ󋵂ŏ͊
	 *	 (TSF ͂gȂƐݒ) ƂB
	 */
	g_bInitTSF	= TRUE ;
	return	TRUE ;
}

BOOL	PASCAL
bTSF_IsTSFEnabled (void)
{
	BOOL		bRetval		= FALSE ;

	if (g_bSkkImeSecure) 
		return	FALSE ;

	if (g_bInitTSF) {
		if (g_hMSCTF != NULL) {
			bRetval	= _IsCtfThreadInputManagerEnabled () ;
		}
	} else {
		HMODULE	hMSCTF ;

		hMSCTF	= LoadLibrary (TEXT ("msctf.dll")) ;
		if (hMSCTF != NULL) {
			FreeLibrary (hMSCTF) ;
			bRetval	= _IsCtfThreadInputManagerEnabled () ;
		}
	}
	return	bRetval ;
}

BOOL	PASCAL
bTSF_DoesThreadMgrExistp (void)
{
	BOOL	bRetval	= FALSE ;

	if (g_bSkkImeSecure) 
		return	TRUE ;

	if (g_bInitTSF) {
		if (g_hMSCTF != NULL) {
			ITfThreadMgr*	pThreadMgr	= NULL ;

			pThreadMgr	= _GetThreadMgr () ;
			if (pThreadMgr != NULL) {
				pThreadMgr->Release () ;
				bRetval	= TRUE ;
			}
		}
	}
	return	bRetval ;
}


BOOL	PASCAL
bTSF_UpdateLanguageBar (HIMC hIMC)
{
	ITfLangBarItemMgr*	pLangBarItemMgr			= NULL ;
	DWORD				dwValue ;
	BOOL				fRetval	= FALSE ;
	BOOL				fShowKeyboardIcon, fShowIMEIcon, fShowInputModeIcon ;
	HANDLE				hMutex ;

	if (g_bSkkImeSecure)
		return	FALSE ;

	if (g_hMSCTF == NULL || ! _IsCtfThreadInputManagerEnabled ())
		goto	exit_func ;

	DEBUGPRINTFEX (99, (TEXT ("UpdateLanguageBar (hIMC:%p)\n"), hIMC)) ;

	/*	񃌃WXgQƂ̂͐̂낤H */
	fShowKeyboardIcon	= fShowIMEIcon	= fShowInputModeIcon	= TRUE ;
#if !defined (NO_TOUCH_REGISTRY)
	if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWKEYBRDICON), &dwValue))
		fShowKeyboardIcon	= (BOOL) dwValue ;
	if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWIMEICON), &dwValue))
		fShowIMEIcon		= (BOOL) dwValue ;
	if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWINPUTMODEICON), &dwValue))
		fShowInputModeIcon	= (BOOL) dwValue ;
#endif
	pLangBarItemMgr	= _QueryLangBarItemMgr () ;
	if (pLangBarItemMgr != NULL) {
		ITfLangBarItem*		pItem ;
					
		if (g_bInitTSF) {
			__try {
				if (fShowInputModeIcon) {
					pItem	= NULL ;
					if (pLangBarItemMgr->GetItem (c_guidItemButtonCMode, &pItem) == S_OK && pItem != NULL) {
						hrButtonCMode_SetActiveContext (pItem, hIMC) ;
						//hrButtonCMode_Update (pItem) ;
						pItem->Release () ;
					}
				}
				if (fShowIMEIcon) {
					pItem	= NULL ;
					if (pLangBarItemMgr->GetItem (c_guidItemButtonIME, &pItem) == S_OK && pItem != NULL) {
						hrButtonIME_SetActiveContext (pItem, hIMC) ;
						//hrButtonIME_Update (pItem) ;
						pItem->Release () ;
					}
				}
				_showKeyboardIcon (pLangBarItemMgr, fShowKeyboardIcon) ;
			} __finally {
				pLangBarItemMgr->Release () ;
			}
		}
	}
  exit_func:
	return	fRetval ;
}

/*	o[ɃACeǉ/폜B
 */
void	PASCAL
vTSF_ActivateLanguageBar (
	HIMC		hIMC,
	BOOL		fSelect)
{
	ITfLangBarItemMgr*	pLangBarItemMgr			= NULL ;
	DWORD				dwValue ;
	BOOL				fShowKeyboardIcon, fShowIMEIcon, fShowInputModeIcon ;

	if (g_bSkkImeSecure)
		return ;

	if (g_hMSCTF == NULL ||  ! _IsCtfThreadInputManagerEnabled ())
		goto	Exit_Func ;

	DEBUGPRINTFEX (99, (TEXT ("ActivateLanguageBar (Select:%d, hIMC:%p)\n"), fSelect, hIMC)) ;

	/*	񃌃WXgQƂ̂͐̂낤H */
	fShowKeyboardIcon	= fShowIMEIcon	= fShowInputModeIcon	= TRUE ;
	if (fSelect) {
#if !defined (NO_TOUCH_REGISTRY)
		if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWKEYBRDICON), &dwValue))
			fShowKeyboardIcon	= (BOOL) dwValue ;
		if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWIMEICON), &dwValue))
			fShowIMEIcon		= (BOOL) dwValue ;
		if (GetRegDwordValue (TEXT ("\\CICERO"), TEXT(REGKEY_SHOWINPUTMODEICON), &dwValue))
			fShowInputModeIcon	= (BOOL) dwValue ;
#endif
	}
	pLangBarItemMgr	= _QueryLangBarItemMgr () ;
	if (pLangBarItemMgr != NULL) {
		ITfLangBarItem*		pItem ;
		ITfLangBarItem*		pNewItem ;
		HRESULT				hrBtnIME = S_OK, hrBtnCMode = S_OK ;

		__try {
			pItem	= NULL ;
			if (pLangBarItemMgr->GetItem (c_guidItemButtonIME, &pItem) == S_OK && pItem != NULL) {
				if (! fShowIMEIcon || ! fSelect) {
#if defined (DBG)
					HRESULT	hr	= pLangBarItemMgr->RemoveItem (pItem) ;
					if (FAILED (hr)) {
						DebugPrintf (TEXT ("c_guidItemButtonIME remove failed. (0x%x)\n"), hr) ;
					} else {
						DebugPrintf (TEXT ("c_guidItemButtonIME was removed.\n")) ;
					}
					hrBtnIME	= hr ;
#else
					hrBtnIME	= pLangBarItemMgr->RemoveItem (pItem) ;
#endif
				}
				pItem->Release () ;
			} else {
#if defined (DBG)
				DebugPrintf (TEXT ("GetItem (c_guidItemButtonIME) ... ng (%d && %d)\n"), fShowIMEIcon, fSelect) ;
#endif
				if (fShowIMEIcon && fSelect) {
					pNewItem	= NULL ;
					if (bButtonIME_Create (hIMC, &pNewItem) && pNewItem != NULL) {
#if defined (DBG)
						HRESULT	hr	= pLangBarItemMgr->AddItem (pNewItem) ;
						if (FAILED (hr)) {
							DebugPrintf (TEXT ("c_guidItemButtonIME add failed. (0x%x)\n"), hr) ;
						} else {
							DebugPrintf (TEXT ("c_guidItemButtonIME was added.\n")) ;
						}
						hrBtnIME	= hr ;
#else
						hrBtnIME	= pLangBarItemMgr->AddItem (pNewItem) ;
#endif
						pNewItem->Release () ;
					} else {
						hrBtnIME	= E_FAIL ;
					}
				}
			}

			pItem	= NULL ;
			if (pLangBarItemMgr->GetItem (c_guidItemButtonCMode, &pItem) == S_OK && pItem != NULL) {
				if (! fShowInputModeIcon || ! fSelect) {
					hrBtnCMode	= pLangBarItemMgr->RemoveItem (pItem) ;
#if defined (DBG)
					DebugPrintf (TEXT ("c_guidItemButtonCMode was removed (hr:0x%x).\n"), hrBtnCMode) ;
#endif
				}
				pItem->Release () ;
			} else {
#if defined (DBG)
				DebugPrintf (TEXT ("GetItem (c_guidItemButtonCMode) ... ng (%d && %d)\n"), fShowIMEIcon, fSelect) ;
#endif
				if (fShowInputModeIcon && fSelect) {
					pNewItem	= NULL ;
					if (bButtonCMode_Create (hIMC, &pNewItem) && pNewItem != NULL) {
						hrBtnCMode	= pLangBarItemMgr->AddItem (pNewItem) ;
#if defined (DBG)
						DebugPrintf (TEXT ("c_guidItemButtonCMode was added (hr:0x%x).\n"), hrBtnCMode) ;
#endif
						pNewItem->Release () ;
					} else {
						hrBtnCMode	= E_FAIL ;
					}
				}
			}
			if (fSelect)
				_showKeyboardIcon (pLangBarItemMgr, fShowKeyboardIcon) ;
		} __finally {
			pLangBarItemMgr->Release () ;
		}
#if defined (DBG)
	} else {
		DebugPrintf (TEXT ("_QueryLangBarItemMgr failed.\n")) ;
#endif
	}
  Exit_Func:
	return ;
}

/*	L[{[hACR(o[)̕\/\؂ւ֐B
 *
 *	Text Service Framework ƓĂꍇɂ̓L[{[h̃ACR
 *	\邪AłȂꍇɂ IME ICON p悤łB
 */
BOOL
bTSF_ShowKeyboardIcon (
	BOOL				fShow)
{
	ITfLangBarItemMgr*	pLangBarItemMgr			= NULL ;
	BOOL				bRetval	;

	pLangBarItemMgr	= _QueryLangBarItemMgr () ;
	if (pLangBarItemMgr == NULL) 
		return	FALSE ;

	bRetval	= _showKeyboardIcon (pLangBarItemMgr, fShow) ;
	pLangBarItemMgr->Release () ;
	return	bRetval ;
}

void	PASCAL
vTSF_UninitLanguageBar (void)
{
	ITfLangBarItemMgr*	pLangBarItemMgr			= NULL ;
	int	i ;

	
	if (g_bSkkImeSecure) {
		return ;
	}
	if (g_hMSCTF != NULL) {
		FreeLibrary (g_hMSCTF) ;
		g_hMSCTF	= NULL ;
	}
	g_bInitTSF	= FALSE ;
	return ;
}

/*========================================================================
 */
ITfThreadMgr*
_QueryThreadMgr (void)
{
	PTF_CREATETHREADMGR	pfnCreateThreadMgr	= NULL ;
	ITfThreadMgr*		pThreadMgr			= NULL ;
	HRESULT				hr ;

	if (g_hMSCTF == NULL)
		return	NULL ;

	pfnCreateThreadMgr = (PTF_CREATETHREADMGR)GetProcAddress (g_hMSCTF, "TF_CreateThreadMgr") ;
	if(pfnCreateThreadMgr) {
		hr = (*pfnCreateThreadMgr)(&pThreadMgr) ;
		if (SUCCEEDED (hr) && pThreadMgr != NULL) 
			return	pThreadMgr ;
	}
	return	NULL ;
}

ITfLangBarItemMgr*
_QueryLangBarItemMgr (void)
{
	PTF_CREATELANGBARITEMMGR	pfnCreateLangBarItemMgr	= NULL ;
	ITfLangBarItemMgr*			pLangBarItemMgr			= NULL ;
	HRESULT				hr ;

	if (g_hMSCTF == NULL)
		return	NULL ;

	pfnCreateLangBarItemMgr	= (PTF_CREATELANGBARITEMMGR)GetProcAddress (g_hMSCTF, "TF_CreateLangBarItemMgr") ;
	if (pfnCreateLangBarItemMgr == NULL) 
		return	NULL ;

	hr = (*pfnCreateLangBarItemMgr)(&pLangBarItemMgr) ;
	if (SUCCEEDED (hr)) 
		return	pLangBarItemMgr ;
	return	NULL ;
}

typedef HRESULT (WINAPI *PTF_GETTHREADMGR)(ITfThreadMgr **pptim);

ITfThreadMgr *
_GetThreadMgr (void)
{
    HRESULT				hr				= E_FAIL ;
    ITfThreadMgr*		pThreadMgr		= NULL ;
	PTF_GETTHREADMGR	pfnGetThreadMgr	= NULL ;

	if (g_hMSCTF == NULL)
		return	NULL ;

	pfnGetThreadMgr = (PTF_GETTHREADMGR)GetProcAddress(g_hMSCTF, "TF_GetThreadMgr");
	if(pfnGetThreadMgr == NULL)
		return	NULL ;

	hr = (*pfnGetThreadMgr)(&pThreadMgr);
	if (SUCCEEDED (hr))
		return	pThreadMgr ;
	return	NULL ;
}

HIMC
_GetCurrentHIMC (void)
{
	HIMC	hIMC	= NULL ;

	HWND	hwnd	= GetFocus () ;
	if (hwnd != NULL)
		hIMC	= ImmGetContext (hwnd) ;
	return	hIMC ;
}

BOOL
_showKeyboardIcon (
	ITfLangBarItemMgr*	pLangBarItemMgr,
	BOOL				fShow)
{
	ITfLangBarItem*					pItem ;

	if (SUCCEEDED (pLangBarItemMgr->GetItem (c_guidKeyboardItemButton, &pItem))) {
		if (fShow) {
			ITfSystemLangBarItem*			pSysItem ;
			ITfSystemDeviceTypeLangBarItem*	pSysDevItem ;

			if (SUCCEEDED (pItem->QueryInterface (IID_ITfSystemDeviceTypeLangBarItem, (void**)&pSysDevItem)) && pSysDevItem != NULL) {
				pSysDevItem->SetIconMode (0) ;
				pSysDevItem->Release () ;
			}
		}
		pItem->Show (fShow) ;
		pItem->Release () ;
	}
	return	TRUE ;
}

BOOL
_IsCtfThreadInputManagerEnabled (void)
{
	HKEY	hKey ;
	DWORD	dwRegType, dwData, dwDataSize, dwRet ;
	BOOL	bRetval ;

	bRetval		= TRUE ;
	dwData		= 0 ;
	dwDataSize	= sizeof (DWORD) ;
	if (RegOpenKeyEx (HKEY_CURRENT_USER, REGPATH_CTF_PATH, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
		dwRet	= RegQueryValueEx (hKey, REGKEY_CTF_DISABLE_THREAD_INPUT_MANAGER, NULL, &dwRegType, (LPBYTE)&dwData, &dwDataSize) ;
		RegCloseKey (hKey) ;
		if (dwRet == ERROR_SUCCESS && dwRegType == REG_DWORD)
			bRetval	= (dwData == 0) ;
	}
	return	bRetval ;
}

void
_DumpLangBarItem (void)
{
	ITfLangBarItemMgr*	pLangBarItemMgr			= NULL ;
	ITfLangBarItem*			pItem ;
	IEnumTfLangBarItems*	pEnum ;

	pLangBarItemMgr	= _QueryLangBarItemMgr () ;
	if (pLangBarItemMgr == NULL) 
		return ;

	DebugPrintf (TEXT ("--[Enter: _DumpLangBarItem (%d)]--\n"), (int) GetTickCount ()) ; 
	if (SUCCEEDED (pLangBarItemMgr->EnumItems (&pEnum))) {
		ITfLangBarItem*	rpItems [16]	= { NULL } ;
		ULONG			cItems	= 0 ;
		if (SUCCEEDED (pEnum->Next (16, rpItems, &cItems))) {
			ULONG		i ;
			for (i = 0 ; i < cItems ; i ++) {
				TF_LANGBARITEMINFO	info ;
				if (SUCCEEDED (rpItems [i]->GetInfo (&info))) {
				    const BYTE*		pBytes	= (const BYTE *) &(info.guidItem) ;
					DebugPrintf (TEXT ("(%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x)\n"),
						pBytes [0], pBytes [1], pBytes [2], pBytes [3],
						pBytes [4], pBytes [5], pBytes [6], pBytes [7], 
						pBytes [8], pBytes [9], pBytes [10], pBytes [11],
						pBytes [12], pBytes [13], pBytes [14], pBytes [15]) ;
				}
			}
			for (i = 0 ; i < cItems ; i ++) {
				rpItems [i]->Release () ;
				rpItems [i]	= NULL ;
			}
		}
		pEnum->Release () ;
	}
	return ;
}

#endif

