/* # SKKIME1.0 (Simple Kana-Kanji Input Method Editor for Windows2000)
 * uinotify.c
 * This file is part of skkime1.0.
 * Copyright (C) 1999
 * Takashi SAKAMOTO (tatari_sakamoto@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "skki1_5.h"

/*
 *	vg^Cv錾B
 */
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnCloseStatusWindow		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnOpenStatusWindow		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnChangeCandidate		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnCloseCandidate			(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnOpenCandidate			(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetConversionMode		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetSentenceMode		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetOpenStatus			(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetCandidatePos		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetCompositionFont		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetCompositionWindow	(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnSetStatusWindowPos		(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnGuideLine				(HIMC, HWND, UINT, WPARAM, LPARAM) ;
static	LRESULT	PASCAL	tSkkImeWnd_lOnImnPrivate				(HIMC, HWND, UINT, WPARAM, LPARAM) ;

/*
 *	Public Function
 */

/*************************************************************************
 *	WM_IME_NOTIFY
 *------------------------------------------------------------------------
 *		WM_IME_NOTIFY bZ[W̓AvP[V UI window IME
 *		̏Ԃʒm submessage ̏W܂łB
 *		WM_IME_NOTIFY
 *			wSubMessage	= wParam ;
 *			lParam		= lParam ;
 *************************************************************************/
LRESULT	PASCAL
TSkkImeWnd_lOnImeNotify (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		message,
	WPARAM		wParam,
	LPARAM		lParam)
{
	static	LRESULT	(PASCAL *rpImnFunctionTable [])(HIMC, HWND, UINT, WPARAM, LPARAM) = {
		NULL,									tSkkImeWnd_lOnImnCloseStatusWindow,
		tSkkImeWnd_lOnImnOpenStatusWindow,		tSkkImeWnd_lOnImnChangeCandidate,
		tSkkImeWnd_lOnImnCloseCandidate,		tSkkImeWnd_lOnImnOpenCandidate,
		tSkkImeWnd_lOnImnSetConversionMode,		tSkkImeWnd_lOnImnSetSentenceMode,		
		tSkkImeWnd_lOnImnSetOpenStatus,			tSkkImeWnd_lOnImnSetCandidatePos,		
		tSkkImeWnd_lOnImnSetCompositionFont,	tSkkImeWnd_lOnImnSetCompositionWindow,	
		tSkkImeWnd_lOnImnSetStatusWindowPos,	tSkkImeWnd_lOnImnGuideLine,
		tSkkImeWnd_lOnImnPrivate,
	} ;
	LRESULT	lRes ;

	if (wParam <= 0 || wParam > IMN_PRIVATE || !rpImnFunctionTable [wParam])
		return	0L ;

	DEBUGPRINTFEX (106, (MYTEXT ("TSkkImeWnd_lOnImeNotify (himc:0x%0x, w:0x%lx, l:0x%lx)\n"), (DWORD) hUICurIMC, wParam, lParam)) ;
	lRes	= (rpImnFunctionTable [wParam])(hUICurIMC, hWnd, message, wParam, lParam) ;
	return	lRes ;
}

/*
 *	Private Functions
 */

/*************************************************************************
 *	IMN_CLOSESTATUSWINDOW
 *		IMN_CLOSESTATUSWINDOW bZ[W IME  status window 悤
 *		ƂĂ鎞ɑ܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_CLOSESTATUSWINDOW ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			pB
 *	(Ԃl)
 *		ȂB
 *	(Rg)
 *		UI window ͂̃bZ[W󂯎 status window ܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnCloseStatusWindow (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	RECT			rc ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	if (hUIExtra != NULL) {
		lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
		if (lpUIExtra != NULL) {
			/* status window ݂ȂȂ΂ȂȂB*/
			if (IsWindow (lpUIExtra->uiStatus.hWnd)){
				GetWindowRect (lpUIExtra->uiStatus.hWnd, (LPRECT)&rc) ;
				lpUIExtra->uiStatus.pt.x	= rc.left ;
				lpUIExtra->uiStatus.pt.y	= rc.top ;
				ShowWindow (lpUIExtra->uiStatus.hWnd, SW_HIDE) ;
				lpUIExtra->uiStatus.bShow	= FALSE ;
			}
			GlobalUnlock (hUIExtra) ;
		}
	}

#if !defined (NO_TSF)
	vTSF_ActivateLanguageBar (hUICurIMC, FALSE) ;
#endif
	/*	ImeSelect 炱ɈړĂ݂B(Thu Dec 08 23:33:08 2005)
	 *	̈ʒuƏH MS-IME ƔrĂ̈ۂł͂邪B
	TSkkIme_vUpdateIndicIcon (hUICurIMC) ;
	 */
	return	0L ;
}

/*************************************************************************
 *	IMN_OPENSTATUSWINDOW
 *		IMN_OPENSTATUSWINDOW bZ[W IME  status window 낤
 *		Ă鎞ɑ܂BAvP[V͂̎̃bZ[W
 *		IMEsystem window\܂BAvP[V
 *		ImmGetConversionStatus ֐ĂяoƂsystem window̏
 *		邱Ƃł܂B
 *	WM_IME_NOTIFY
 *		wSubMessage = IMN_OPENSTATUSWINDOW;
 *		lParam= 0;
 *	(p[^)
 *		lParam
 *			p܂B
 *	(Ԃl)
 *		Nothing
 *	(Rg)
 *		UI window ͂̃bZ[W󂯎 status window 쐬܂B
 *	See Also
 *		ImmGetConversionStatus
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnOpenStatusWindow (
	HIMC			hUICurIMC,
	HWND			hWnd,
	UINT			uMsg,
	WPARAM			wParam,
	LPARAM			lParam)
{
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	RECT			rc ;
	HINSTANCE		hInstance ;
	int				cx, cy ;
	POINT			pt ;
	HANDLE			hMutex ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	hInstance	= (HINSTANCE)GetWindowLongPtr (hWnd, GWLP_HINSTANCE) ;

#if !defined (NO_TSF)
	/*	TSF LȂ Status Window ͕svB
	 */
	if (bTSF_IsTSFEnabled ()) {
		if (IsWindow (lpUIExtra->uiStatus.hWnd)) 
			DestroyWindow (lpUIExtra->uiStatus.hWnd) ;
		lpUIExtra->uiStatus.pt.x	= -1 ;
		lpUIExtra->uiStatus.pt.y	= -1 ;
		lpUIExtra->uiStatus.hWnd 	= NULL ;
		lpUIExtra->uiStatus.bShow	= FALSE ;
		vTSF_ActivateLanguageBar (hUICurIMC, TRUE) ;
	} else {
#endif
		/* TASK Bar ̗̈ʂ̑傫𓾂B*/
		cx	= STATUS_BTNX + 2 * GetSystemMetrics (SM_CXBORDER) + 2 * GetSystemMetrics (SM_CXEDGE) ;
		cy	= STATUS_BTNY + 2 * GetSystemMetrics (SM_CYBORDER) + 2 * GetSystemMetrics (SM_CYEDGE) ;
		SystemParametersInfo (SPI_GETWORKAREA, 0, &rc, 0) ;

		pt.x	= (lpUIExtra->uiStatus.pt.x != -1)? lpUIExtra->uiStatus.pt.x : (rc.right  - cx) ;
		pt.y	= (lpUIExtra->uiStatus.pt.x != -1)? lpUIExtra->uiStatus.pt.y : (rc.bottom - cy) ;
		hMutex	= TSkkIme_hCreateMutex (SKKIME_MUTEX_NAME) ;
		if (hMutex != NULL) {
			DWORD	dw = WaitForSingleObject (hMutex, INFINITE) ;
			if (dw != WAIT_FAILED && dw != WAIT_TIMEOUT) {
				if (g_ptUIStatus.x == -1) {
					g_ptUIStatus.x			= rc.right  - cx ;
					g_ptUIStatus.y			= rc.bottom - cy ;
				}
				if (g_ptUIStatus.x < rc.left)
					g_ptUIStatus.x	= rc.left ;
				if (g_ptUIStatus.x > rc.right)
					g_ptUIStatus.x	= rc.right - cx ;
				if (g_ptUIStatus.y < rc.top)
					g_ptUIStatus.y	= rc.top ;
				if (g_ptUIStatus.y > rc.bottom)
					g_ptUIStatus.y	= rc.bottom - cy ;

				pt.x	= g_ptUIStatus.x ;
				pt.y	= g_ptUIStatus.y ;
				ReleaseMutex (hMutex) ;
			}
			CloseHandle (hMutex) ;
		}
		lpUIExtra->uiStatus.pt.x	= pt.x ;
		lpUIExtra->uiStatus.pt.y	= pt.y ;

		/* window ݂ĂȂACreateWindow gB*/
		if (!IsWindow (lpUIExtra->uiStatus.hWnd)){
			lpUIExtra->uiStatus.hWnd = 
				CreateWindowEx (WS_EX_WINDOWEDGE | WS_EX_DLGMODALFRAME,
								(LPTSTR)g_szStatusClassName, NULL,
								WS_DISABLED | WS_POPUP | WS_BORDER,
								lpUIExtra->uiStatus.pt.x,
								lpUIExtra->uiStatus.pt.y,
								cx,
								cy,
								hWnd, NULL, hInstance, NULL) ;
		}
		/* window \B*/
		if (! TSkkIme_bIsHideToolbarp ()){
			/*	 SetWindowPos sƁAShowWindow ƈႢ X-Mouse Ƃ
			 *	ȂB*/
			SetWindowPos (lpUIExtra->uiStatus.hWnd, HWND_TOP, 0, 0, 1, 1, 
				SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_NOSENDCHANGING | SWP_NOOWNERZORDER | SWP_SHOWWINDOW) ;
			/*ShowWindow (lpUIExtra->uiStatus.hWnd, SW_SHOWNOACTIVATE) ;*/
			lpUIExtra->uiStatus.bShow	= TRUE ;
		} else {
			ShowWindow (lpUIExtra->uiStatus.hWnd, SW_HIDE) ;
			lpUIExtra->uiStatus.bShow	= FALSE ;
		}
		SetWindowLongPtr (lpUIExtra->uiStatus.hWnd, FIGWL_UISTATE_SVRWND, (LONG_PTR)hWnd) ;
#if !defined (NO_TSF)
	}
#endif
	GlobalUnlock (hUIExtra) ;
	TSkkIme_vUpdateIndicIcon (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_SETCONVERSIONMODE
 *		IMN_SETCONVERSIONMODE bZ[W Input Context ̕ϊ[hX
 *		Vꂽɑ܂BAvP[V UI window ͂
 *		bZ[W󂯎ƁAImmGetConversionStatus ĂяoāA
 *		status window ̏𓾂邱Ƃł܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_SETCONVERSIONMODE ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			gĂ܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		UI window  status window ϊ[h\ĂA
 *		status window ĕ`悵Ȃ΂Ȃ܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetConversionMode (
	HIMC			hUICurIMC,
	HWND			hWnd,
	UINT			uMsg,
	WPARAM			wParam,
	LPARAM			lParam)
{
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	int	nCmd ;

	/* ԂvB*/
	TSkkIme_vUpdateIndicIcon (hUICurIMC) ;
#if !defined (NO_TSF)
	bTSF_UpdateLanguageBar (hUICurIMC) ;
#endif

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;

	/* status window ĕ`悳B*/
	UIStatus_Update (lpUIExtra) ;
	GlobalUnlock (hUIExtra) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_SETSENTENCEMODE
 *		IMN_SETSENTENCEODE bZ[W Input Context ̓̕[h(H)X
 *		Vꂽɑ܂BAvP[V UI window ͂
 *		bZ[W󂯎ƁAImmGetConversionStatus g
 *		status window ̏𓾂邱Ƃł܂B(AߕϊǂƂ)
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_SETSENTENCEMODE ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			gĂ܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		status window ̓[h\ĂAUI window 
 *		status window ĕ`悷Kv܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetSentenceMode (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	/* ̓[h͕\ĂȂgĂȂ̂ŉȂB*/
	return	0L ;
}

/*************************************************************************
 *	IMN_SETCOMPOSITIONFONT
 *		IMN_SETCOMPOSITIONFONT  Input Context ̃tHgXVꂽ
 *		܂BAvP[V UI window ͂̃bZ[W
 *		󂯎ƁAǂ炩Е ImmGetCompositionFont Ăяo
 *		composition font Ɋւ𓾂邱Ƃł܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_SETCOMPOSITIONFONT ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			gĂ܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		UI window  composition componet  ImmGetCompositionFont Ă
 *		oƂœtHggāAcomposition string 
 *		eLXg`悷B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetCompositionFont (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL		hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	MYLOGFONT	lf ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
#if defined (MIXED_UNICODE_ANSI) || defined (UNICODE)
	lf			= lpIMC->lfFont.W ;
#else
	lf			= lpIMC->lfFont.A ;
#endif
	if (lpUIExtra->hFont)
		DeleteObject(lpUIExtra->hFont) ;
	if (lf.lfEscapement == 2700){
		lpUIExtra->bVertical	= TRUE ;
	} else {
		lf.lfEscapement			= 0 ;
		lpUIExtra->bVertical	= FALSE ;
	}
	if (lf.lfCharSet != NATIVE_CHARSET) {
		lf.lfCharSet			= NATIVE_CHARSET ;
		lf.lfFaceName[0]		= TEXT ('\0') ;
	}
	lpUIExtra->hFont	= MyCreateFontIndirect ((LPMYLOGFONT)&lf) ;
	UIComp_SetFont (lpUIExtra) ;
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_SETOPENSTATUS
 *		IMN_SETOPENSTATUS bZ[W Input Context  open status XV
 *		ꂽɑ܂BAvP[V UI window ͂̃bZ[
 *		W󂯎ƁAǂ ImmGetOpenStatus ĂяoƂŏ
 *		邱Ƃł܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_SETOPENSTATUS ;
 *		lParam		= 0 ;
 *	Parameters
 *		lParam
 *			gĂȂłB
 *	(Ԃl)
 *		łB
 *	Comments
 *		 status window  open/close status \ȂAUI window
 *		 status window ĕ`悵܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetOpenStatus (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	HGLOBAL		hUIExtra ;
	LPUIEXTRA		lpUIExtra ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	UIStatus_Update (lpUIExtra) ;
	GlobalUnlock (hUIExtra) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_OPENCANDIDATE
 *		IMN_OPENCANDIDATE bZ[WIMEcandidate windowJƂ
 *		ɑ܂BAvP[V͂̃bZ[W
 *		ImmGetCandidateCount y ImmGetCandidateList Ăяo
 *		candidate window \܂B
 *	WM_IME_NOTIFY
 *		wSubMessage		= IMN_OPENCANDIDATE ;
 *		lCandidateList	= lParam ;
 *	(p[^)
 *		lCandidateList
 *			ǂ̌⃊XgXVׂ\킵܂Brbg01
 *			ŏ̌⃊XgAbvf[g܂Brbg311Ȃ
 *			32Ԗڂ̌⃊XgAbvf[g܂B
 *	(Ԃl)
 *		ȂB
 *	(Rg)
 *		̃bZ[W󂯎 UI window ͌EBhE쐬܂B
 *	See Also
 *	ImmGetCandidateListCount, ImmGetCandidateList, WM_IME_CHANGECANDIDATE
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnOpenCandidate (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL		hUIExtra ;
	LPUIEXTRA		lpUIExtra ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	/* EBhE쐬B*/
	UICand_Create (hWnd, lpUIExtra, lpIMC) ;
	UICand_Move (hWnd, lpIMC, lpUIExtra, FALSE) ;
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_CHANGECANDIDATE
 *		IMN_CHANGECANDIDATE bZ[W IME EBhE̒gύX
 *		悤ƂĂ鎞ɑ܂BAvP[V͂̃bZ[W
 *		ČEBhE\܂B
 *	WM_IME_NOTIFY
 *		wSubMessage		= IMN_CHANGECANDIDATE ;
 *		lCandidateList	= lParam ;
 *	(p[^)
 *		lCandidateList
 *			ǂ̌⃊XgXVׂ\킵܂Brbg01
 *			ŏ̌⃊XgAbvf[g܂Brbg311Ȃ
 *			32Ԗڂ̌⃊XgAbvf[g܂B
 *	(Ԃl)
 *		ȂB
 *	(Rg)
 *		̃bZ[W󂯎 UI window ͌EBhEĕ`悵
 *		B
 *	See Also
 *		ImmGetCandidateCount, ImmGetCandidateList
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnChangeCandidate (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	if (!hUICurIMC)
		return	0L ;
	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;
	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	if (!IsWindow (lpUIExtra->uiCand.hWnd))
		UICand_Create (hWnd, lpUIExtra, lpIMC) ;
	UICand_Move (hWnd, lpIMC, lpUIExtra, FALSE) ;
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_CLOSECANDIDATE
 *		IMN_CLOSECANDIDATE bZ[WIMEEBhE悤Ƃ
 * 		ɑ܂BAvP[V͂̃bZ[WāA
 *		Ăend(H)𓾂܂B
 *	WM_IME_NOTIFY
 *		wSubMessage		= IMN_CLOSECANDIDATE ;
 *		lCandidateList	= lParam ;
 *	(p[^)
 *		lCandidateList
 *			ǂ̌⃊Xgׂ\킵܂Brbg01
 *			ŏ̌⃊XgAbvf[g܂Brbg311Ȃ
 *			32Ԗڂ̌⃊XgAbvf[g܂B
 *	(Ԃl)
 *		ȂB
 *	(Rg)
 *		̃bZ[W󂯎 UI window ͌EBhEj܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnCloseCandidate (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	UICand_Hide (lpUIExtra) ;
	GlobalUnlock (hUIExtra) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_GUIDELINE
 *		IMN_GUIDELINE bZ[W IME G[͏\悤
 *		鎞ɑ܂BAvP[V UI window ͂̃b
 *		Z[W󂯎ƁAImmGetGuideLine ĂяoƂŃKChC
 *		𓾂邱Ƃł܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_GUIDELINE ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			gĂȂłBłȂ΂Ȃ܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		̃bZ[W󂯎AUI window  information window 
 *		āAinformation string \܂B
 *	See Also
 *		ImmGetGuideLine, GUIDELINE structure
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnGuideLine (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL		hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	DWORD					dwSize, dwLevel ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	DEBUGPRINTFEX (99, (TEXT ("tSkkImeWnd_lOnImnGuideLine () -- enter\n"))) ;
	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;

	/* ImmGetGuideLine gāAinformation string 𓾂B*/
	if (ImmGetGuideLine (hUICurIMC, GGL_LEVEL, NULL, 0)){
		dwLevel	= ImmGetGuideLine (hUICurIMC, GGL_LEVEL, NULL, 0) ;
		if (dwLevel) {
			dwSize	= ImmGetGuideLine (hUICurIMC, GGL_STRING, NULL, 0) ;
		} else {
			dwSize	= 0 ;
		}
		DEBUGPRINTFEX (99, (TEXT ("tSkkImeWnd_lOnImnGuideLine (lev:%d, len:%d)\n"),
							(int) dwLevel, (int) dwSize)) ;
		if (dwSize > 0) {
			if (!IsWindow (lpUIExtra->uiGuide.hWnd))
				UIMinibuf_Create (hWnd, lpUIExtra, lpIMC) ;
			ShowWindow (lpUIExtra->uiGuide.hWnd, SW_SHOWNOACTIVATE) ;
			lpUIExtra->uiGuide.bShow	= TRUE ;
			UIMinibuf_NotifyComposition (lpUIExtra->uiGuide.hWnd, lpUIExtra, lpIMC) ;
		} else {
			UIMinibuf_Hide (lpUIExtra) ;
		}
	}
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_SETCANDIDATEPOS
 *		IMN_SETCANDIDATEPOS bZ[W͌\ړ悤Ƃ
 * 		܂BAvP[V͂̃bZ[WāAĂ
 *		end(H)𓾂܂B
 *	WM_IME_NOTIFY
 *		wSubMessage		= IMN_SETCANDIDATEPOS ;
 *		lCandidateList	= lParam ;
 *	(p[^)
 *		lCandidateList
 *			ǂ̌⃊Xgړ̂܂Brbg01Ȃ
 *			ԍŏ̌⃊XgXV܂Brbg311ȂA32Ԗڂ
 *			⃊XgXV܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		UI window ͂̃bZ[W󂯎ƌEBhEړ
 *		B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetCandidatePos (
	HIMC				hUICurIMC,
	HWND				hWnd,
	UINT				uMsg,
	WPARAM				wParam,
	LPARAM				lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	/* ⃊Xg1ԈȊO͗pĂ܂̂ŁAȊO͖܂B*/
	if (lParam != 0x01){
		ImmUnlockIMC (hUICurIMC) ;
		return	0L ;
	}

	/* EBhEړ܂cB*/
	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	UICand_Move (hWnd, lpIMC, lpUIExtra, FALSE) ;
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

/*************************************************************************
 *	IMN_SETCOMPOSITIONWINDOW
 *		IMN_SETCOMPOSITIONWINDOW bZ[W Input Context  composition
 *		form XVꂽɑ܂BUI window ͂̃bZ[W
 *		ƁAInput Context  cfCompForm QƂĐVϊ[hl
 *		܂B
 *	WM_IME_NOTIFY
 *		wSubMessage	= IMN_SETCOMPOSITIONWINDOW ;
 *		lParam		= 0 ;
 *	(p[^)
 *		lParam
 *			gĂ܂B
 *	(Ԃl)
 *		łB
 *	(Rg)
 *		UI window  composition component  cfCompForm g composition
 *		window \܂B
 *************************************************************************/
LRESULT	PASCAL
tSkkImeWnd_lOnImnSetCompositionWindow (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	UIComp_Move (hWnd, lpUIExtra, lpIMC) ;
	UICand_Move (hWnd, lpIMC, lpUIExtra, TRUE) ;
	UIMinibuf_Move (hWnd, lpUIExtra, lpIMC) ;
	GlobalUnlock (hUIExtra) ;
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

LRESULT	PASCAL
tSkkImeWnd_lOnImnSetStatusWindowPos (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;
	POINTS			pt ;

	DEBUGPRINTFEX (99, (TEXT ("IMC_SETSTATUSWINDOWPOS\n"))) ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	if (! hUIExtra)
		goto	exit_func ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	if (! lpUIExtra)
		goto	exit_func ;

	pt.x		= (SHORT) LOWORD (lParam) ;
	pt.y		= (SHORT) HIWORD (lParam) ;
	UIStatus_Move (lpUIExtra, &pt) ;
	GlobalUnlock (hUIExtra) ;
exit_func:
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

LRESULT	PASCAL
tSkkImeWnd_lOnImnPrivate (
	HIMC		hUICurIMC,
	HWND		hWnd,
	UINT		uMsg,
	WPARAM		wParam,
	LPARAM		lParam)
{
	LPINPUTCONTEXT	lpIMC ;
	HGLOBAL			hUIExtra ;
	LPUIEXTRA		lpUIExtra ;

	if (!hUICurIMC)
		return	0L ;

	lpIMC	= ImmLockIMC (hUICurIMC) ;
	if (!lpIMC)
		return	0L ;

	hUIExtra	= (HGLOBAL)GetWindowLongPtr (hWnd, IMMGWLP_PRIVATE) ;
	if (! hUIExtra)
		goto	exit_func ;
	lpUIExtra	= (LPUIEXTRA)GlobalLock (hUIExtra) ;
	if (! lpUIExtra)
		goto	exit_func ;

	switch ((long)lParam){
	case	IMN_PRIVATE_INDICICON:
	{
		TSkkIme_vUpdateIndicIcon (hUICurIMC) ;
		break ;
	}
	case	IMN_PRIVATE_SHOWSTATUSWINDOW:
	{
		if (IsWindow (lpUIExtra->uiStatus.hWnd)){
			if (! TSkkIme_bIsHideToolbarp ()){
				/*	 SetWindowPos sƁAShowWindow ƈႢ X-Mouse Ƃ
				 *	ȂB*/
				UIStatus_Show (lpUIExtra) ;
				//SetWindowPos (lpUIExtra->uiStatus.hWnd, HWND_TOP, 0, 0, 1, 1, 
				//	SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_NOSENDCHANGING | SWP_NOOWNERZORDER | SWP_SHOWWINDOW) ;
				/*ShowWindow (lpUIExtra->uiStatus.hWnd, SW_SHOWNOACTIVATE) ;*/
				lpUIExtra->uiStatus.bShow	= TRUE ;
			} else {
				ShowWindow (lpUIExtra->uiStatus.hWnd, SW_HIDE) ;
				lpUIExtra->uiStatus.bShow	= FALSE ;
			}
		}
		break ;
	}
	case	IMN_PRIVATE_ACTIVATECONTEXT:
	{
		if (IsWindow (lpUIExtra->uiStatus.hWnd) &&
			lpUIExtra->uiStatus.bShow &&
			! TSkkIme_bIsHideToolbarp ()){
			/*	 SetWindowPos sƁAShowWindow ƈႢ X-Mouse Ƃ
			 *	ȂB
			*/
			//UIStatus_Show (lpUIExtra) ;
			//SetWindowPos (lpUIExtra->uiStatus.hWnd, HWND_TOP, 0, 0, 1, 1, 
			//	SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE | SWP_NOSENDCHANGING | SWP_NOOWNERZORDER | SWP_SHOWWINDOW) ;
			/*ShowWindow (lpUIExtra->uiStatus.hWnd, SW_SHOWNOACTIVATE) ;*/

			/*	The following code is buggy. If there are any suspended process,
			 *	this function call will be locked. (Because suspended process can't 
			 *	reply ``ShowWindow'')
			 *	So, when DEACTIVATECONTEXT, it is better choice to use ``ShowWindow''
			 *	to hide status windows.
			 *
			 *	HideOtherWindows (szStatusClassName, NULL, lpUIExtra->uiStatus.hWnd) ;
			 */
		}
		TSkkIme_vUpdateIndicIcon (hUICurIMC) ;
#if !defined (NO_TSF)
		/*	Activate ͎s Update ݂̂ɂB
		vTSF_ActivateLanguageBar (hUICurIMC, TRUE) ;//commented out
		 */
		(void) bTSF_UpdateLanguageBar (hUICurIMC) ;
#endif
		break ;
	}
	case	IMN_PRIVATE_DEACTIVATECONTEXT:
	{
		/*	 SW_HIDE 邩A ACTIVATE ɑ STATUS WINDOW
		 *	 HIDE 邩̂ǂ炩ȂƁAWindow cĂ܂B
		 *	A HideOtherWindows  Suspend Ă Window (Process) 
		 *	݂ lock Ă܂B܂A̐ӔC̎ĂvZXȊO
		 *	ɗ]vȂƂ͂Ă͂ȂcƂB
		 *
		 *	̃R[hLɂĂƁAڍׂȃeLXgT[rX֎~ԂŁA
		 *	IE Ȃǂ application sĂ status window \Ȃ܂
		 *	ɂȂĂ܂B
		 *	ActiveContext  DeactiveContext ΂ɂȂĂȂ߂ Hide ͓K؂
		 *	͂Ȃ悤B(Wed Nov 09 21:40:13 2005)
		 *
		if (IsWindow (lpUIExtra->uiStatus.hWnd)) {
			ShowWindow (lpUIExtra->uiStatus.hWnd, SW_HIDE) ;
		}
		 */
		break ;
	}
	default:
		break ;
	}
	GlobalUnlock (hUIExtra) ;
exit_func:
	ImmUnlockIMC (hUICurIMC) ;
	return	0L ;
}

