#include "StdAfx.h"
#include <lmcons.h>
#include "TCommuSession.h"
#include "TPacket.h"
#include "TProtocol.h"

#define	SKKIME_PIPE_PREFIX_NUM		(29)
#define	OPENSERVER_MAX_RETRY		(128)
#define	SKKISERVER_PIPE_BASENAME	L"\\\\.\\pipe\\skkiserv010500_pipe_%s"
#define	PROGRAMF_DIR				L"IME"
#define	SKKIMEProg_S_DIR			L"SKKIM15"
#define	SKKIMEServerFile			L"skkiserv.exe"

/*========================================================================
 *	prototypes
 */
static	BOOL	tCommunicateSession_bInitPipeName	(void) ;
static	BOOL	tCommunicateSession_bStartServer	(void) ;

/*========================================================================
 *	global variables
 */
static	WCHAR	m_rszSkkImePipeName [MAX_PATH]	= SKKISERVER_PIPE_BASENAME ;

HANDLE
TCommunicateSession_hOpenServer (void)
{
	register HANDLE		hPipe ;
	register int		nRetry ;
	register BOOL		fServerStart ;

	hPipe			= INVALID_HANDLE_VALUE ;
	nRetry			= OPENSERVER_MAX_RETRY ;
	fServerStart	= FALSE ;
	for ( ; ; ) {
		register DWORD	dwError ;

		hPipe	= CreateFileW (m_rszSkkImePipeName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL) ;
		dwError	= GetLastError () ;
		if (hPipe != INVALID_HANDLE_VALUE) {
			break ;
		}
		if (dwError != ERROR_PIPE_BUSY) {
			/*	T[oȂAȂĂꍇɂ͉ȂB
			 */
			break ;
		}
		/*	PIPE  BUSY łȂȂ̂҂BA҂
		 *	PIPE  BUSY łȂȂ̂ɐ䂪߂ȂƂ̂
		 *	(^C~OˑH)
		 *	莞Ԃŏ𔲂ABUSY Ȃēx҂AƂƂJ
		 *	ԂB
		 */
		if (WaitNamedPipeW (m_rszSkkImePipeName, 100) == 0) {
			dwError	= GetLastError () ;
			if (dwError != ERROR_SEM_TIMEOUT && dwError != ERROR_FILE_NOT_FOUND)
				break ;
		}
	}
	return	hPipe ;
}

BOOL
TCommunicateSession_bSend (
	HANDLE							hPipe,
	struct CTPacket*				pPacket)
{
	register const BYTE*	ptr ;
	register int		nptr ;
	DWORD				dwWrite ;

	ptr			= TPacket_pGetData (pPacket) ;
	nptr		= TPacket_iGetDataSize (pPacket) ;
	while (nptr > 0) {
		if (! WriteFile (hPipe, ptr, nptr, &dwWrite, NULL)) {
			return	FALSE ;
		}
		ptr		+= dwWrite ;
		nptr	-= dwWrite ;
	}
	FlushFileBuffers (hPipe) ;
	return	TRUE ;
}

BOOL
TCommunicateSession_bRecv (
	HANDLE							hPipe,
	struct CTPacket*				pPacket)
{
	DWORD	dwRead ;

	if (! ReadFile (hPipe, TPacket_pGetData (pPacket), TPACKET_MSGBUFSIZE, &dwRead, NULL)) {
		return	FALSE ;
	}
	TPacket_vSetDataSize (pPacket, dwRead) ;
	return	TRUE ;
}

BOOL
TCommunicateSession_bClassInit (void)
{
	WCHAR		rszUserName [UNLEN + 1] ;
	ULONG		ulUserNameLen ;
	LPWSTR		ptr ;

	ulUserNameLen	= sizeof (rszUserName) / sizeof (rszUserName [0]) - 1 ;
	if (! GetUserNameW (rszUserName, &ulUserNameLen)) 
		return	FALSE ;
	rszUserName [UNLEN]	= TEXT ('\0') ;

	/*	VXe[U͍ȂcƂB
	 *
	 *	VXeƒʏ̃[U̓vZXԂL̂ŁA skkiserv
	 *	NƁAsystem ̃vtB[œĂ skkiserv Ɉʃ[
	 *	U query 邱ƂɂȂ...ʃ[U̐ݒ肪fȂȂ
	 *	܂B
	 *	``SYSTEM'' 炵ǁAcase ĔrB
	 */
	if (! lstrcmpiW (rszUserName, L"system")) 
		return	FALSE ;

	ptr	= rszUserName ;
	while (*ptr != L'\0') {
		/*	pXƂĎgpłȂ͎̂̂ĂB*/
		if (*ptr == L'\\' || *ptr == L'*' || *ptr == L'?' ||
			*ptr == L':'  || *ptr == L'.' || *ptr == L'/') {
			*ptr = L'-' ;
		}
		ptr	++ ;
	}
	wnsprintf (m_rszSkkImePipeName, MAX_PATH - 1, SKKISERVER_PIPE_BASENAME, rszUserName) ;
	m_rszSkkImePipeName [MAX_PATH - 1]	= L'\0' ;
	return	TRUE ;
}

BOOL
tCommunicateSession_bStartServer (void)
{
	WCHAR					rszWindowsDir [MAX_PATH + 1] ;
	WCHAR					rszCmd [MAX_PATH + 1] ;
    STARTUPINFOW			si ;
    PROCESS_INFORMATION		pi ;
	register int			nWindowsDir, n ;
	register BOOL			fRetval ;

	nWindowsDir	= GetWindowsDirectoryW (rszWindowsDir, ARRAYSIZE (rszWindowsDir) - 1) ;
	rszWindowsDir [nWindowsDir]		= L'\0' ;
	n			= wnsprintf (rszCmd, ARRAYSIZE (rszCmd) - 1, L"%s" L"\\" PROGRAMF_DIR L"\\" SKKIMEProg_S_DIR L"\\" SKKIMEServerFile, rszWindowsDir) ;
	rszCmd [n]	= L'\0' ;


	ZeroMemory (&si, sizeof(si)) ;
	si.cb	= sizeof (si) ;

	/*	 pipename n\ɖ߂Ă݂B(PTNVQS())
	 *	Windows2000sp4  skkiserv  connect s錻ۂ̂ŁB
	 *	͂̏낤H 
	 *	̂ skkiserv  pipename ɍĂƗ\zĂ鎞
	 *	if (! CreateProcessW (rszCmd, L"", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
	 *	B
	 */
	if (! CreateProcessW (rszCmd, m_rszSkkImePipeName + SKKIME_PIPE_PREFIX_NUM, NULL, NULL, FALSE, 0, NULL, rszWindowsDir, &si, &pi)) {
		fRetval	= FALSE ;
	} else {
		WaitForInputIdle (pi.hProcess, 3000) ;
		
		/* svɂȂnhB*/
		CloseHandle (pi.hProcess) ;
		CloseHandle (pi.hThread) ;
		fRetval	= TRUE ;
	}
	return	fRetval ;
}

